#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

std::string minimizeNumberWithSwaps(const std::string& inputString, int swapLimit) {
    std::vector<char> digits(inputString.begin(), inputString.end());
    int numberOfDigits = digits.size();
    
    int currentIndex = 0;
    while (currentIndex < numberOfDigits && swapLimit > 0) {
        int minimumIndex = currentIndex;
        for (int nextIndex = currentIndex + 1; nextIndex < std::min(currentIndex + swapLimit + 1, numberOfDigits); ++nextIndex) {
            if (digits[nextIndex] < digits[minimumIndex]) {
                minimumIndex = nextIndex;
            }
        }

        if (minimumIndex != currentIndex) {
            char minimumDigit = digits[minimumIndex];
            for (int shiftIndex = minimumIndex; shiftIndex > currentIndex; --shiftIndex) {
                digits[shiftIndex] = digits[shiftIndex - 1];
            }
            digits[currentIndex] = minimumDigit;
            swapLimit -= (minimumIndex - currentIndex);
        }

        currentIndex += 1;
    }

    return std::string(digits.begin(), digits.end());
}

int main() {
    int testCases;
    std::cin >> testCases;
    std::cin.ignore();

    std::vector<std::string> results;
    for (int i = 0; i < testCases; ++i) {
        std::string inputString;
        int swapLimit;
        std::getline(std::cin, inputString);
        std::istringstream(inputString) >> inputString >> swapLimit;
        results.push_back(minimizeNumberWithSwaps(inputString, swapLimit));
    }

    for (const auto& result : results) {
        std::cout << result << std::endl;
    }

    return 0;
}
