
#include <iostream>
#include <vector>
using namespace std;

const int MOD = 998244353;

long long modInverse(long long x, long long mod) {
    return pow(x, mod - 2, mod);
}

pair<vector<long long>, vector<long long>> precomputeFactorialsUpTo(int maxVal, int mod) {
    vector<long long> factorials(maxVal + 1, 1);
    vector<long long> inverseFactorials(maxVal + 1, 1);
    
    for (int i = 2; i <= maxVal; ++i) {
        factorials[i] = factorials[i - 1] * i % mod;
    }
    
    inverseFactorials[maxVal] = modInverse(factorials[maxVal], mod);
    for (int i = maxVal - 1; i > 0; --i) {
        inverseFactorials[i] = inverseFactorials[i + 1] * (i + 1) % mod;
    }
    
    return {factorials, inverseFactorials};
}

int main() {
    int redCount, greenCount, blueCount;
    cin >> redCount >> greenCount >> blueCount;

    int totalCount = redCount + greenCount + blueCount;

    if (max(redCount, max(greenCount, blueCount)) > (totalCount + 1) / 2) {
        cout << 0 << endl;
    } else {
        auto [factorials, inverseFactorials] = precomputeFactorialsUpTo(totalCount, MOD);

        long long result = factorials[totalCount] * inverseFactorials[redCount] % MOD 
                        * inverseFactorials[greenCount] % MOD 
                        * inverseFactorials[blueCount] % MOD;

        if (redCount == greenCount && greenCount == blueCount) {
            cout << result << endl;
        } else {
            result = result * modInverse(2, MOD) % MOD;
            cout << result << endl;
        }
    }

    return 0;
}