#include <bits/stdc++.h>

struct s_tree {
    std::vector <long long> a, sum, promise;
    s_tree(std::vector <long long> a_) {
        a = a_;
        int n = a.size();
        sum.resize(4 * n);
        promise.resize(4 * n, 0);
        build(0, 0, n);
    }
    
    void build(int id, int l, int r) {
        if (l + 1 == r) {
            sum[id] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(id * 2 + 1, l, m);
        build(id * 2 + 2, m, r);
        sum[id] = sum[id * 2 + 1] + sum[id * 2 + 2];
    }

    void push(int id, int l, int r) {
        if (promise[id] == 0) {
            return;
        }
        sum[id] += promise[id] * (r - l);
        if (r - l > 1) {
            promise[id * 2 + 1] += promise[id];
            promise[id * 2 + 2] += promise[id];
        }
        promise[id] = 0;
    }

    long long get(int id, int l, int r, int q_l, int q_r) {
        push(id, l, r);
        if (q_l <= l && r <= q_r) {
            push(id, l, r);
            return sum[id];
        }
        if (q_l >= r || q_r <= l) {
            return 0;
        }
        int m = (l + r) / 2;
        long long s1 = get(id * 2 + 1, l, m, q_l, q_r);
        long long s2 = get(id * 2 + 2, m, r, q_l, q_r);
        return s1 + s2;
    }

    void upd(int id, int l, int r, int q_l, int q_r, long long up) {
        push(id, l, r);
        if (q_l <= l && r <= q_r) {
            promise[id] += up;
            push(id, l, r);
            return;
        }
        if (q_l >= r || q_r <= l) {
            return;
        }
        int m = (l + r) / 2;
        upd(id * 2 + 1, l, m, q_l, q_r, up);
        upd(id * 2 + 2, m, r, q_l, q_r, up);
        sum[id] = sum[id * 2 + 1] + sum[id * 2 + 2];
    }

    void write() {
        for (int i = 0; i < a.size(); ++i) {
            std::cout << get(0, 0, a.size(), i, i + 1) << ' ';
        }
        std::cout << '\n';
    }
};

void solve() {
    long long n, k;
    std::string s;
    std::cin >> s >> k;
    n = s.size();
    std::vector <long long> for_s_tree(n);
    auto a = s_tree(for_s_tree);
    std::vector <std::vector <int>> pos(10);
    for (int i = n - 1; i >= 0; --i) {
        pos[s[i] - '0'].push_back(i);
    }
    std::set <int> used;
    for (int i = 0; i < n; ++i) {
        used.insert(i);
    }
    std::vector <int> ans;
    for (int i = 0; i < n; ++i) {
        int cnt = s[*used.begin()] - '0';
        int f = cnt;
        for (int j = 1; j < cnt; ++j) {
            if (pos[j].empty()) {
                continue;
            }
            int t = pos[j].back() + a.get(0, 0, n, pos[j].back(), pos[j].back() + 1);
            if (t - i <= k) {
                k -= t - i;
                a.upd(0, 0, n, i, pos[j].back(), 1);
                used.erase(pos[j].back());
                pos[j].pop_back();
                f = j;
                break;
            }
        }
        ans.push_back(f);
        if (f == cnt) {
            used.erase(used.begin());
            pos[f].pop_back();
        }
    }
    for (auto i : ans) {
        std::cout << i;
    }
    std::cout << '\n';
}

int main() {
    // std::ios_base::sync_with_stdio(false);
    // std::cin.tie(nullptr);
    // std::cout.tie(nullptr);
    unsigned long long t = 1;
    std::cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
