#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

// Функция для нахождения нового члена VIPERR
string find_new_viperr_member(string s, int k) {
    int n = s.size();
    for (int i = 0; i < n && k > 0; ++i) {
        // Находим минимальный элемент, который можно переместить на позицию i
        int min_pos = i;
        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < s[min_pos]) {
                min_pos = j;
            }
        }

        // Если минимальная позиция осталась прежней, пропускаем
        if (min_pos == i) continue;

        // Перемещаем минимальный элемент на позицию i
        for (int j = min_pos; j > i; --j) {
            swap(s[j], s[j - 1]);
        }

        // Обновляем количество доступных перемещений
        k -= (min_pos - i);
    }
    return s;
}

int main() {
    // Оптимизация ввода/вывода
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        string s;
        int k;
        cin >> s >> k;
        string new_viperr_member = find_new_viperr_member(s, k);
        cout << new_viperr_member << endl;
    }
    return 0;
}