def count_arrangements(r, g, b, MOD=998244353):
    if r > g + b + 1 or g > r + b + 1 or b > r + g + 1:
        return 0

    def factorial_mod(n):
        result = 1
        for i in range(1, n + 1):
            result = (result * i) % MOD
        return result

    def power_mod(base, exp):
        if exp == 0:
            return 1
        if exp == 1:
            return base % MOD
        half = power_mod(base, exp // 2)
        if exp % 2 == 0:
            return (half * half) % MOD
        return (((half * half) % MOD) * base) % MOD

    def inverse_mod(n):
        return power_mod(n, MOD - 2)

    def permutation_with_repetition(total, *counts):
        numerator = factorial_mod(total)
        denominator = 1
        for count in counts:
            if count > 0:
                denominator = (denominator * factorial_mod(count)) % MOD
        return (numerator * inverse_mod(denominator)) % MOD

    total = 0
    total_balls = r + g + b

    for first_color in range(3):
        counts = [r, g, b]
        if counts[first_color] == 0:
            continue

        counts[first_color] -= 1

        def count_ways(prev_color, remaining_balls):
            if remaining_balls == 0:
                return 1

            result = 0
            for next_color in range(3):
                if next_color != prev_color and counts[next_color] > 0:
                    counts[next_color] -= 1
                    result = (result + count_ways(next_color, remaining_balls - 1)) % MOD
                    counts[next_color] += 1
            return result

        total = (total + count_ways(first_color, total_balls - 1)) % MOD

        counts[first_color] += 1

    return total


r, g, b = map(int, input().split())

print(count_arrangements(r, g, b))