#include <iostream>
#include <list>
#include <vector>
#include <string>
using namespace std;

// Функция для минимизации числа с помощью перестановок
void minimizeNumber(vector<pair<string, long long>>& test_cases) {
    ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    for (auto& test_case : test_cases) {
        string s = test_case.first;
        long long k = test_case.second;

        // Преобразуем строку в список символов для удобства вставки и удаления
        list<char> digits(s.begin(), s.end());
        auto it = digits.begin();

        for (int i = 0; i < s.size() && k > 0; ++i) {
            auto min_it = it;
            auto current = it;

            // Ищем минимальный элемент, который можно переместить на позицию it за оставшиеся перестановки
            for (int j = 0; j <= k && current != digits.end(); ++j) {
                if (*current < *min_it) {
                    min_it = current;
                }
                if (current != digits.end()) ++current;
            }

            // Если минимальный элемент не находится на текущей позиции, перемещаем его сюда
            if (min_it != it) {
                // Считаем количество перестановок, необходимых для перемещения минимального элемента
                int moves = std::distance(it, min_it);

                // Сохраняем символ минимального элемента
                char min_digit = *min_it;

                // Удаляем минимальный элемент
                digits.erase(min_it);

                // Вставляем минимальный элемент перед текущей позицией
                it = digits.insert(it, min_digit);

                // Обновляем оставшееся количество перестановок
                k -= moves;
            }

            // Переходим к следующему элементу
            ++it;
        }

        // Выводим минимизированное число
        for (char digit : digits) {
            cout << digit;
        }
        cout << endl;
    }
}

int main() {
    int t;
    cin >> t;
    vector<pair<string, long long>> test_cases(t);

    for (int i = 0; i < t; ++i) {
        string s;
        long long k;
        cin >> s >> k;
        test_cases[i] = { s, k };
    }

    minimizeNumber(test_cases);

    return 0;
}