#include <iostream>
#include <deque>
#include <vector>  
#include <string>
#include <utility>   

using namespace std;

void minimizeNumber(vector<pair<string, long long>>& test_cases) {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    for (auto& test_case : test_cases) {
        string s = test_case.first;
        long long k = test_case.second;
        int n = s.size();

        for (int i = 0; i < n && k > 0; ++i) {
            deque<pair<char, int>> min_deque;

            for (int j = i + 1; j < n && (j - i) <= k; ++j) {
                while (!min_deque.empty() && min_deque.back().first >= s[j]) {
                    min_deque.pop_back();
                }
                min_deque.emplace_back(s[j], j);
            }

            char min_digit = s[i];
            int min_index = i;
            if (!min_deque.empty() && min_deque.front().first < s[i]) {
                min_digit = min_deque.front().first;
                min_index = min_deque.front().second;
            }

            if (min_index != i) {
                long long operations_needed = min_index - i;
                for (int j = min_index; j > i; --j) {
                    s[j] = s[j - 1];
                }
                s[i] = min_digit;

                k -= operations_needed;
            }
        }

        cout << s << endl;
    }
}

int main() {
    int t;
    cin >> t;
    vector<pair<string, long long>> test_cases(t);

    for (int i = 0; i < t; ++i) {
        string s;
        long long k;
        cin >> s >> k;
        test_cases[i] = {s, k};
    }

    minimizeNumber(test_cases);

    return 0;
}
