def get_digit_representation():
    return [
        "1110111",  # 0
        "0010010",  # 1
        "1011101",  # 2
        "1011011",  # 3
        "0111010",  # 4
        "1101011",  # 5
        "1101111",  # 6
        "1010010",  # 7
        "1111111",  # 8
        "1111011",  # 9
    ]

def can_display(digit_rep, faulty_rep):
    for d, f in zip(digit_rep, faulty_rep):
        if d == '1' and f == '0':
            return False
    return True

def main():
    import sys
    input = sys.stdin.read
    data = input().strip().splitlines()
    
    first_digit_faulty = data[0]
    second_digit_faulty = data[1]
    
    digit_rep = get_digit_representation()
    
    max_k = 0
    
    for y in range(99, 0, -1):
        current_k = 0
        while True:
            actual_num = y - current_k
            if actual_num < 1:
                break
            
            y_first_digit = y // 10
            y_second_digit = y % 10
            
            actual_first_digit = actual_num // 10
            actual_second_digit = actual_num % 10
            
            if (y_first_digit > 0 and actual_first_digit > 0 and 
                can_display(digit_rep[y_first_digit], first_digit_faulty) and 
                can_display(digit_rep[actual_first_digit], first_digit_faulty) and
                can_display(digit_rep[y_second_digit], second_digit_faulty) and 
                can_display(digit_rep[actual_second_digit], second_digit_faulty)):
                current_k += 1
            else:
                break
        
        max_k = max(max_k, current_k)
    
    print(max_k)

if __name__ == "__main__":
    main()