#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

void minimizeNumber(string &s, long long k) {
    int n = s.length();

    for (int i = 0; i < n; ++i) {
        if (k <= 0) break; // Если операций больше нет, выходим из цикла

        // Ищем наименьшую цифру в пределах доступных операций
        char minChar = s[i];
        int minPos = i;

        for (int j = i + 1; j < n && j <= i + k; ++j) {
            if (s[j] < minChar) {
                minChar = s[j];
                minPos = j;
            }
        }

        // Если нашли меньшую цифру, перемещаем ее на позицию i
        if (minPos != i) {
            // Количество операций, необходимых для перемещения
            long long movesNeeded = minPos - i;

            // Если можем переместить, то делаем это
            if (movesNeeded <= k) {
                // Перемещаем символы
                for (int j = minPos; j > i; --j) {
                    swap(s[j], s[j - 1]);
                }
                // Уменьшаем количество оставшихся операций
                k -= movesNeeded;
            }
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    cin.ignore(); // Игнорируем символ новой строки после чтения t

    while (t--) {
        string s;
        long long k;

        cin >> s >> k;
        minimizeNumber(s, k);
        cout << s << '\n';
    }

    return 0;
}