﻿#include <iostream>
#include <vector>
#include <string>

using namespace std;

const vector<string> digits = {
    "1111110",
    "0110000", 
    "1101101", 
    "1111001",
    "0110011",
    "1011011", 
    "1011111"
    "1110000", 
    "1111111",
    "1111011" 
};

bool canDisplay(const string& segmentState, int digit) {
    const string& required = digits[digit];
    for (int i = 0; i < 7; i++) {
        if (required[i] == '1' && segmentState[i] == '0') {
            return false;
        }
    }
    return true;
}

void getDigits(int number, int& firstDigit, int& secondDigit) {
    firstDigit = number / 10;
    secondDigit = number % 10;
}

int main() {
    string firstDigitState, secondDigitState;
    cin >> firstDigitState >> secondDigitState;

    int maxK = 0;

    for (int y = 99; y >= 1; y--) {
        bool valid = true;
        int k = 0;

        while (true) {
            int current = y - k;
            if (current < 1) break;

            int firstDigit, secondDigit;
            getDigits(current, firstDigit, secondDigit);

            if (!canDisplay(firstDigitState, firstDigit) || !canDisplay(secondDigitState, secondDigit)) {
                break; 
            }
            k++; 
        }

        if (k > maxK) {
            maxK = k; 
        }
    }

    cout << maxK << endl;

    return 0;
}
