﻿#include <iostream>
#include <string>
#include <vector>
#include <algorithm> 

using namespace std;

vector<string> min_number(int t, const vector<pair<string, long long>>& test_cases) {
    vector<string> results;

    for (const auto& test_case : test_cases) {
        string s = test_case.first;
        long long k = test_case.second;
        int n = s.length();

        for (int i = 0; i < n; ++i) {
            if (k <= 0) {
                break;
            }

            long long limit = min(i + k, (long long)(n - 1));
            int min_pos = i;

            for (int j = i + 1; j <= limit; ++j) {
                if (s[j] < s[min_pos]) {
                    min_pos = j;
                }
            }

            long long moves_needed = min_pos - i;

            if (moves_needed <= k) {
                char min_digit = s[min_pos];
                for (int j = min_pos; j > i; --j) {
                    s[j] = s[j - 1];
                }
                s[i] = min_digit;

                k -= moves_needed;
            }
        }

        results.push_back(s);
    }

    return results;
}

int main() {
    int t;
    cin >> t;
    vector<pair<string, long long>> test_cases;

    for (int i = 0; i < t; ++i) {
        string s;
        long long k;
        cin >> s >> k;
        test_cases.emplace_back(s, k);
    }

    vector<string> results = min_number(t, test_cases);

    for (const string& result : results) {
        cout << result << endl;
    }

    return 0;
}
