﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

bool comparePoints(const pair<int, int>& a, const pair<int, int>& b) {
	return a.first < b.first;
}

double calculateArea(const pair<int, int>& a, const pair<int, int>& b, const pair<int, int>& c) {
	return 0.5 * abs((b.first - a.first) * (c.second - a.second) - (c.first - a.first) * (b.second - a.second));
}

int main() {
	int n;
	cin >> n;
	vector<pair<int,int>> points(n);
	for (int i = 0; i < n; ++i) {
		cin >> points[i].first >> points[i].second;
	}

	sort(points.begin(), points.end(), comparePoints);

	double maxArea = 0.0;

	for (int i = 0; i < n; ++i) {
		for (int j = i + 1; j < n; ++j) {
			if (points[i].second == 0 && points[j].second == 0) {
				for (int k = 0; k < n; ++k) {
					if (k != i && k != j && points[k].second != 0) {
						double area = calculateArea(points[i], points[j], points[k]);
						if (area > maxArea) {
							maxArea = area;
						}
					}
				}
			}
		}
	}

	cout.precision(10);
	cout << fixed << maxArea << endl;

	return 0;
}
