﻿#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<long long>> d(n, vector<long long>(n));


    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> d[i][j];
        }
    }


    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j && d[i][j] <= 0) {
                cout << "No\n";
                return 0;
            }
            if (i != j) {
                for (int k = 0; k < n; k++) {
                    if (k != i && k != j && d[i][j] > d[i][k] + d[k][j]) {
                        cout << "No\n";
                        return 0;
                    }
                }
            }
        }
    }


    vector<bool> visited(n, false);
    int edges = 0;
    queue<int> q;

    visited[0] = true;
    q.push(0);

    while (!q.empty()) {
        int current = q.front();
        q.pop();

        for (int j = 0; j < n; j++) {
            if (!visited[j] && d[current][j] > 0) {
                visited[j] = true;
                q.push(j);
                edges++; 
            }
        }
    }


    if (edges == n - 1) {
        cout << "Yes\n";
    }
    else {
        cout << "No\n";
    }

    return 0;
}
