#include <iostream>
#include <vector>
#include <limits>

using namespace std;

void solve() {
  int n;
  cin >> n;
  if (n < 3) {
    cout << "Yes" << endl;
    return;
  }

  vector<vector<int>> M(n, vector<int>(n));
  int etd = 0;

  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      cin >> M[i][j];
      if (i < j) {
        etd += M[i][j];
      }
    }
  }

  vector<bool> vis(n, false);
  vector<int> min_e(n, numeric_limits<int>::max());
  min_e[0] = 0;
  int mst_edges = 0;
  int td = 0;

  for (int i = 0; i < n; i++) {
    int u = -1;
    for (int v = 0; v < n; v++) {
      if (!vis[v] && (u == -1 || min_e[v] < min_e[u])) {
        u = v;
      }
    }

    if (min_e[u] == numeric_limits<int>::max()) {
      cout << "No" << endl;
      return;
    }

    vis[u] = true;
    td += min_e[u];
    mst_edges++;

    for (int v = 0; v < n; v++) {
      if (!vis[v]) {
        if (M[u][v] < min_e[v]) {
          min_e[v] = M[u][v];
        }
        for (int k = 0; k < n; k++) {
          if (u != k && v != k && M[u][v] > M[u][k] + M[k][v]) {
            cout << "No" << endl;
            return;
          }
        }
      }
    }
  }

  cout << (mst_edges == n && td == etd ? "Yes" : "No") << endl;
}

int main() {
  solve();
  return 0;
}
