﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <queue>

std::string min_num(std::string s, unsigned long long k)
{
    int n = s.length();

    for (int i = 0; i < n && k > 0; i++)
    {
        int max_move = std::min(k, (unsigned long long)(n - 1 - i));
        char min_digit = s[i];
        int min_pos = i;

        for (int j = i + 1; j <= i + max_move; j++)
        {
            if (s[j] < min_digit) {
                min_digit = s[j];
                min_pos = j;
            }
        }

        if (min_pos != i)
        {
            k -= (min_pos - i);
            std::rotate(s.begin() + i, s.begin() + min_pos, s.begin() + min_pos + 1);
        }
    }

    return s;
}

int main()
{
    int t;
    std::cin >> t;

    std::vector<std::string> results;

    for (int i = 0; i < t; i++)
    {
        std::string s;
        long long k;
        std::cin >> s >> k;
        results.push_back(min_num(s, k));
    }

    for (const auto& res : results)
        std::cout << res << std::endl;

    return 0;
}