﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

std::string minimize_number(std::string s, int k)
{
    int n = s.length();
    for (int i = 0; i < n; i++)
    {
        if (k == 0)
            break;

        int min_pos = i;
        for (int j = i + 1; j <= std::min(i + k, n - 1); j++)
        {
            if (s[j] < s[min_pos])
                min_pos = j;
        }
        if (min_pos != i)
        {
            int moves = min_pos - i;
            if (moves <= k)
            {
                char temp = s[min_pos];
                for (int j = min_pos; j > i; j--) 
                {
                    s[j] = s[j - 1];
                }
                s[i] = temp;
                k -= moves;
            }
        }
    }
    return s;
}

int main() {
    int t;
    std::cin >> t;

    std::vector<std::string> results;

    for (int i = 0; i < t; i++) {
        std::string s;
        int k;
        std::cin >> s >> k;
        std::string result = minimize_number(s, k);
        results.push_back(result);
    }

    for (const auto& res : results)
        std::cout << res << std::endl;


    return 0;
}