﻿#include <iostream>
#include <vector>
#include <string>
#include <deque>
#include <algorithm>    

std::string minimize_number(std::string s, int k)
{
    int n = s.length();
    for (int i = 0; i < n && k > 0; i++)
    {
        int min_pos = i;

        int end_pos = std::min(i + k, n - 1);

        for (int j = i + 1; j <= end_pos; j++)
        {
            if (s[j] < s[min_pos])
                min_pos = j;
        }

        if (min_pos != i)
        {
            k -= (min_pos - i);
            char temp = s[min_pos];
            for (int j = min_pos; j > i; j--)
            {
                s[j] = s[j - 1];
            }
            s[i] = temp;
        }
    }
    return s;
}

int main() {
    int t;
    std::cin >> t;

    std::vector<std::string> results;

    for (int i = 0; i < t; i++) 
    {
        std::string s;
        int k;
        std::cin >> s >> k;
        std::string result = minimize_number(s, k);
        results.push_back(result);
    }

    for (const auto& res : results)
        std::cout << res << std::endl;

    return 0;
}