﻿#include <iostream>
#include <vector>
#include <string>
#include <deque>
#include <algorithm>    

std::string minimize_number(std::string s, int k)
{
    int n = s.length();
    if (n > 1)
    {
        bool isDegree = false, isCycled = false;
        int startIndex = 0;
        int i = 0;
        while (k > 0 && !isCycled)
        {
            isCycled = true;
            for (i = 0; i < n - 1 && k > 0; i++)
            {
                if (isDegree)
                {
                    if ((s[i] - '0') <= (s[i + 1] - '0'))
                    {
                        for (int j = i; j > startIndex; j--)
                        {
                            if ((j - startIndex) <= k)
                            {
                                char temp = s[startIndex];
                                s[startIndex] = s[j];
                                s[j] = temp;
                                k -= (j - startIndex);
                                startIndex++;
                                isCycled = false;
                            }
                        }
                        isDegree = false;
                    }
                }
                else
                {
                    if ((s[i] - '0') > (s[i + 1] - '0'))
                    {
                        isDegree = true;
                        startIndex = i;
                    }
                }
            }
            if (isDegree)
            {
                for (int j = i; j > startIndex; j--)
                {
                    if ((j - startIndex) <= k)
                    {
                        char temp = s[startIndex];
                        s[startIndex] = s[j];
                        s[j] = temp;
                        k -= (j - startIndex);
                        startIndex++;
                        isCycled = false;
                    }
                }
            }
        }
    }
    return s;
}

int main() {
    int t;
    std::cin >> t;
    std::vector<std::string> results;
    for (int i = 0; i < t; i++)
    {
        std::string s;
        int k;
        std::cin >> s >> k;
        std::string result = minimize_number(s, k);
        results.push_back(result);
    }
    for (const auto& res : results)
        std::cout << res << std::endl;
    return 0;
}