#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <fstream>
#include <string>
#include <bitset>
#include <ctime>
#include <random>
#include <iterator>
#include <cmath>
#include <queue>
#include <deque>
#include <time.h>
 
using namespace std;
 
#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto b, auto c) {return b > c;})
 
ifstream fin("input.txt");
ofstream fout("output.txt");
 
using ll = long long;
using ld = long double;
using ull = unsigned long long;
 
ll const inf = 1e18;
 
template <class T>
istream& operator>> (istream& in, vector<T>& a)
{
	for (T& e : a)
		in >> e;
	return in;
}
 
template <class T>
ostream& operator<< (ostream& out, const vector<T>& a)
{
	for (const T& e : a)
		out << e << " ";
	return out;
}
 
template<class T, class N> auto min(T a, N b)
{
	return sizeof(a) > sizeof(b) ? min(a, (T)b) : min((N)a, b);
}
 
template<class T, class N> auto max(T a, N b)
{
	return sizeof(a) > sizeof(b) ? max(a, (T)b) : max((N)a, b);
}
 
const ll mod = 998244353;
 
ll bin_pow_mod(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
			res %= mod;
		}
 
		n >>= 1;
		a *= a;
		a %= mod;
	}
 
	return res;
}
 
ll bin_pow(ll a, ll n)
{
	ll res = 1;
	while (n)
	{
		if (n & 1)
		{
			res *= a;
		}
 
		n >>= 1;
		a *= a;
	}
 
	return res;
}
 
ll gcd(ll a, ll b)
{
	while (b)
	{
		a %= b;
		swap(a, b);
	}
	return a;
}
 
random_device rd;
mt19937 mersenne(rd());

void solve();
 
// #define TIME
// #define ONCE
 
signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
 
	ll TT = 1;
#ifndef ONCE 
	cin >> TT;
#endif
	while (TT--)
	{
#ifdef TIME
		clock_t start, end;
 
		start = clock();
#endif
		solve();
#ifdef TIME
		end = clock();
 
		cerr << "\ntime: " << ((double)end - start) / ((double)CLOCKS_PER_SEC) << " s\n";
#endif
		cerr << '\n';
	}
	return 0;
}

ll true_mod(ll a, ll m) {
	if (m < 0) {
		m *= -1;
	}
	return ((a % m) + m) % m;
}
ll true_div(ll a, ll m) {
	return (a - true_mod(a , m)) / m;
}

ll C(ll n, ll k)
{
	if (k == 0 || n == k)
	{
		return 1;
	}
	if (n < k)
	{
		return 0;
	}
	return C(n - 1, k - 1) + C(n - 1, k);
}

void solve() 
{
	ll n, k;
	cin >> n >> k;
	if (k == 1)
	{
		ll l = -1, r = 1e9 + 10;
		while (r - l > 1)
		{
			ll m = (r + l) / 2;
			if (m * (m + 1) / 2 + 1 >= n)
			{
				r = m;
			}
			else
			{
				l = m;
			}
		}
		cout << r << '\n';
		return;
	}
	ll maxK = 64;
	if (k > maxK)
	{
		ll logN = 0;
		ll m = n;
		while (n > 0)
		{
			n >>= 1;
			++logN;
		}
		if (m == (1ll << (logN - 1)))
		{
			logN -= 1;
		}
		cout << logN << '\n';
		return;
	}
	ll maxT = 1e6;
	vector<vector<ll>> dp0(maxK, vector<ll>(maxT, 0)), dp1(maxK, vector<ll>(maxT, 0));
	dp1[0][0] = 1;
	dp0[0][0] = 1;
	for (int k = 1; k < maxK; ++k)
	{
		dp1[k][0] = 1;
		dp0[k][0] = 1;
	}
	for (int t = 1; t < maxT; ++t)
	{
		dp1[0][t] = 1;
		dp0[0][t] = t + 1;
	}

	for (int k = 1; k < maxK; ++k)
	{
		for (int t = 1; t < maxT; ++t)
		{
			dp1[k][t] = dp0[k - 1][t - 1] + dp1[k][t - 1];
			dp0[k][t] = dp1[k][t - 1] + dp0[k][t - 1];
			if (dp0[k][t] > n + 1)
			{
				dp0[k][t] = n + 1;
			}
			if (dp1[k][t] > n + 1)
			{
				dp1[k][t] = n + 1;
			}
		}
	}

	ll l = 0, r = maxT;
	while (r - l > 1)
	{
		ll m = (r + l) / 2;
		if (dp1[k][m] >= n)
		{
			r = m;
		}
		else
		{
			l = m;
		}
	}
	cout << r << '\n';
}
