import kotlin.math.abs
fun binpow(a: Long, b: Long, mod: Long): Long {
    if (b == 0L) return 1
    if (b == 1L) return a
    val x: Long = binpow(a * a % mod, b / 2, mod)
    if (b % 2 == 0L) return x
    return x * a % mod
}

fun rev(x: Long, mod: Long): Long {
    return binpow(x, mod - 2, mod)
}

fun fact(n: Long, mod: Long): Long {
    var x: Long = 1
    for (i in 2..n) x = (x * i) % mod
    return x
}

fun cnk(n: Long, k: Long, mod: Long): Long {
    return (((fact(n, mod) * rev(fact(k, mod), mod)) % mod) * rev(fact(n - k, mod), mod)) % mod
}

fun ml(a: Long, b: Long, c: Long, d: Long, mod: Long, i: Int, x: Long): Long {
    val ans = (((((a * b) % mod) * c) % mod) * d) % mod
//    println("$a $b $c $d  $ans   x$x i$i")
    return ans
}

fun main() {
    val (r, g, b) = readln().split(" ").map { it.toLong() }
    val s = r+b
    val mod = 998244353L
    val d = abs(r-b)
    var ans = 0L
    for (x in d..(g+1)) {
        if (abs(x - d) % 2 == 0L) {
            val y = g+1-x
            val a = (x-d)/2

            val d1 = binpow(2, y, mod)
            val d2 = cnk(x, a, mod)

            if ((s+x)/2 >= g+1) {
                ans += ml(d1, d2, cnk((s+x)/2 -1, g, mod), cnk(g+1, x, mod), mod, 1, x)
            }
            if (y >= 1 && g >= 1 && (s+x)/2 >= g) {
                ans += ml(d1, d2, cnk((s+x)/2 -1, g-1, mod), cnk(g, x, mod), mod, 2, x)
            }
            if (y >= 2 && g >= 2 && (s+x)/2 >= g-1) {
                ans += ml(binpow(2, y-2, mod), d2, cnk((s+x)/2 -1, g-2, mod), cnk(g-1, x, mod), mod, 3, x)
            }
        }
    }
    println(ans % mod)
}
