// #define _GLIBCXX_DEBUG 1

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/priority_queue.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
namespace r = ranges;
namespace v = views;

typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#ifdef LOCAL
#include "debug.h"
#define dbg(o) ({auto asldfj = o; cout << ANSI_BOLD_RED << #o << " = "; cp_debug::debug_(asldfj); asldfj;})
#else
#define debug(...) 533
#define dbg(o) (o)
#endif
#define all(o) o.begin(), o.end()

template <typename K, typename V, template <typename> typename Comp = less> using ordered_map = tree<K, V, Comp<K>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T, template <typename> typename Comp = less> using ordered_set = ordered_map<T, null_type, Comp>;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
template<typename T> T random(T l, T r) { return uniform_int_distribution<T>(l, r)(rng); }

template<typename T> ostream &operator<<(ostream &os, const vector<T> &v) {
    for (const auto &s : v) os << s << " ";
    return os;
}

template<typename T, typename U> ostream &operator<<(ostream &os, const pair<T, U> &v) {
    os << v.first << " " << v.second << " ";
    return os;
}

template<typename T> istream &operator>>(istream &is, vector<T> &v) {
    for (auto &s : v) is >> s;
    return is;
}

template<typename T, typename U> istream &operator>>(istream &is, pair<T, U> &s) {
    is >> s.first >> s.second;
    return is;
}

void solve(istream &cin = std::cin, ostream &cout = std::cout) {
    string line;
    while (line.size() <= 1) {
        getline(cin, line);
    }
    int n;
    sscanf(line.data(), "for (int i = 0; i < %d; i++)", &n);

    std::vector<pair<int, int>> jumps;
    while (1) {
        getline(cin, line);
        if (line[4] == 'i') {
            int from, to;
            sscanf(line.data(), "    if (i == %d) i = %d;", &from, &to);
            jumps.emplace_back(from, to);
        } else if (line[4] == 'w') {
            break;
        }
    }
    getline(cin, line);
    int m = jumps.size();

    std::map<int, pair<int, int>> jumps2;
    for (int i = m - 1; i >= 0; i--) {
        auto [from, to] = jumps[i];
        if (jumps2.contains(to)) {
            auto [to2, cost] = jumps2[to];
            jumps2[from] = {to2, cost + 1};
        } else {
            jumps2[from] = {to, 1};
        }
    }

    dbg(jumps2.size());
    dbg((vector<pair<int, pair<int, int>>>(all(jumps2))));

    int i = 0;
    ll cost = 1;
    bool exited = false;
    for (int iter = 0; iter < m + 100; iter++) {
        auto first_jump = jumps2.lower_bound(i);
        if (first_jump == jumps2.end()) {
            cost += (n - i) * (3 + m);
            exited = true;
            break;
        }
        auto [first_jump_i, jump] = *first_jump;

        cost += (first_jump_i - i + 1) * (3 + m);
        cost += jump.second;
        i = jump.first + 1;
    }
    cost += 1;

    if (exited) {
        cout << cost << "\n";
    } else {
        cout << "-1\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int test = 1;
#if LOCAL
    ifstream cin("../kolya.in"); // ofstream cout("kolya.out");
    cin >> test;
    if (test == 0) cerr << "CHANGE .IN FILE" << endl;
    for (const auto i: v::iota(1) | v::take(test)) {
        const auto divider = string(30, '=');
        cout << divider << ' ' << i << ' ' << divider << '\n';
        solve(cin, cout);
        cout << '\n';
    }
#else
    // ifstream cin(".in"); ofstream cout(".out");
    // cin >> test;
    for (const auto _: v::iota(0, test)) {
        solve(cin, cout);
    }
#endif
}
