//#pragma GCC optimize("O3,unroll-loops,no-stack-protector")
//#pragma GCC target("avx2,avx,sse,sse2,sse3,ssse3,sse4,abm,mmx")
//#pragma GCC march("native")

#include <iostream>
#include <cmath>
#include <vector> 
#include <string>
#include <algorithm>
#include <utility>

#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

template <typename T1, typename T2>
ostream& operator<<(ostream& os, pair<T1, T2> p) {
    os << "(" << p.first << ", " << p.second << ")";
    return os;
} 

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (T& x : v) os << x << " ";
    return os;
}

template<typename T1, typename T2>
ostream& operator<<(ostream& os, map<T1,T2>& m) {
    for (auto& p : m) os << "{" << p.first << "," << p.second << "} ";
    return os;
}

int gcd(int a, int b) {
    if (b == 0) return a;
    return gcd(b, a % b);
}

struct kaban {
    int x;
    int s;
    int f;
    kaban() {}
    kaban(int a, int b, int c): x(a), s(b), f(c) {}
};

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(0);
    std::cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);

    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    int s, f;
    cin >> s >> f;
    s--; f--;
    vector<kaban> kabans;
    int curr_gcd = 0;
    int start = s;
    if (f > s) {
        for (int i = s; i < f; i++) {
            int diff = abs(a[i] - a[i+1]);
            if (diff == 1) {
                cout << "Impossible" << endl;
                return 0;
            }
            if (gcd(curr_gcd, diff) == 1) {
                kabans.push_back({curr_gcd, start, i});
                curr_gcd = 0;
                start = i;
            }
            curr_gcd = gcd(curr_gcd, diff);
        }
        kabans.push_back({curr_gcd, start, f});
    } else {
        for (int i = s - 1; i >= f; i--) {
            int diff = abs(a[i] - a[i+1]);
            if (diff == 1) {
                cout << "Impossible" << endl;
                return 0;
            }
            if (gcd(curr_gcd, diff) == 1) {
                kabans.push_back({curr_gcd, start, i + 1});
                curr_gcd = 0;
                start = i + 1;
            }
            curr_gcd = gcd(curr_gcd, diff);
        }
        kabans.push_back({curr_gcd, start, f});
    }
    for (kaban& k : kabans) {
        cout << "Kaban-" << (k.x == 0 ? 666 : k.x) << " " << k.s + 1 << " " << k.f + 1 << endl;
    }
}