const long long INFLL = 1e18;

#include <bits/stdc++.h>

using namespace std;

#ifdef LOCAL
#define dbg(x) cerr << __LINE__ << " " << #x << " " << x << endl
#define ln cerr << __LINE__ << " fine, thanks" << endl
#else
#define dbg(x) void(0)
#define ln void(0)
#endif 

typedef long long ll;

template <typename T>
istream& operator>>(istream& in, vector<T>& a)
{
    for (auto& e : a) in >> e;
    return in;
}

template <typename T>
ostream& operator<<(ostream& out, const vector<T>& a)
{
    for (auto &e : a)
    {
        out << e << " ";
        if (typeid(T) != typeid(int) && typeid(T) != typeid(long long))
            out << "\n";
    }
    return out;
}

#define forn(i, n) for (int i = 0; (i) != (n); (i)++)
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define popcount(x) __builtin_popcount(x)
#define popcountll(x) __builtin_popcountll(x)
#define fi first
#define se second
#define re return
#define pb push_back
#define uniq(x) sort(all(x)); (x).resize(unique(all(x)) - (x).begin())
#define safe(x, n) (0 <= (x) && (x) < (n))
#define withBit(mask, i) ((mask & (1LL << (i))) > 0)

const int FIXK = 62;
const int MAXANS = 1e6;

void solve()
{
    #define tests

    static long long dp[FIXK][MAXANS][2];
    static int computed = 0;
    if (!computed)
    {
        computed = 1;
        for (int i = 0; i < MAXANS; i++) {
            dp[0][i][1] = i + 1;
        }
        for (int k = 1; k < FIXK; k++) {

            dp[k][0][0] = 1;

            for (int ans = 1; ans < MAXANS; ans++) {
                dp[k][ans][0] = min(dp[k - 1][ans - 1][1] + dp[k][ans - 1][0], INFLL);
            }

            dp[k][0][1] = 1;

            for (int ans = 1; ans < MAXANS; ans++) {
                dp[k][ans][1] = min(dp[k][ans - 1][0] + dp[k][ans - 1][1], INFLL);
            }
        }
    }

    ll n, k;
    cin >> n >> k;

    if (k == 1) {
        ll L = 0, R = 2e9;
        while (L + 1 < R) {
            ll M = (L + R) / 2;
            ll v = M * (M - 1) / 2 + 1;
            if (n <= v) R = M;
            else L = M;
        }
        cout << R - 1 << "\n";
        return;
    }
    if (k >= FIXK) {
        ll ans = 0;
        ll x = 1;
        while (x < n) x *= 2, ans++;
        cout << ans << "\n";
        return;
    }

    ll L = 0, R = MAXANS;
    while (L + 1 < R) {
        ll M = (L + R) / 2;
        if (n <= dp[k][M][0]) R = M;
        else L = M;
    }
    cout << R << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    #ifdef LOCAL
    double st = clock();
    #endif 

    int t = 1;
    #ifdef tests
    cin >> t;
    #endif
    while (t--)
    {
        solve();
    }

    #ifdef LOCAL
    cerr << setprecision(5) << "Succeed in " << (clock() - st) / CLOCKS_PER_SEC << " s\n";
    #endif 
}
