

// === HEAD === 

#ifndef HEAD_H
#define HEAD_H

#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define pb emplace_back
#define mp make_pair
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
#define in(x); { for (auto &itrnjvtntrbr : x) cin >> itrnjvtntrbr; }
#define out(x); { for (auto &itrnjvtntrbr : x) cout << itrnjvtntrbr << ' '; cout << endl; }
#define sz(x) ((int)x.size())

#define rep(i, n) for (int i = 0; i < n; ++i)
#define repr(i, a, b) for (int i = a; i <= b; ++i)
#define per(i, n) for (int i = n -1; i >= 0; i--)
#define perr(i, a, b) for (int i = b; i >= a; --i)

using namespace std;
using namespace __gnu_cxx;
using namespace __gnu_pbds;
 
typedef long long ll;
typedef unsigned long long ull;
typedef pair <int, int> pii;
typedef pair <long long, long long> pll;
typedef vector <int> vi;
typedef vector <long long> vll;
typedef vector <vector <int>> vvi;
typedef vector <pair <int, int>> vii;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
 
const int INF = 2e9;
const long long INFll = 1e18;
const long double eps = 1e-6;
const long double pi = acos(-1);

template<typename T>
T input() {
    T obj;
    cin >> obj;
    return obj;
}

template<typename T>
vector<T> input(int count) {
    vector<T> vec(count);
    for (T& obj : vec)
        obj = input<T>();
    return vec;
}

template<typename T>
T divup(T a, T b) {
    return (a + b - 1) / b;
}

template<typename T, typename F = bool(*)(T)>
T binary_search(F check, T left, T right) {
    while (right - left > 1) {
        T mid = left + (right - left) / 2;
        if (check(mid)) {
            right = mid;
        } else {
            left = mid;
        }
    }
    return right;
}

#endif // HEAD_H


#ifndef CFF_DSU_H
#define CFF_DSU_H

#include <vector>

namespace dsu {

const int INF = 2e9;
using std::vector;

class DSU {
    int _size, _timer;
    vector<int> _parent, _rank, _time;

public:
    DSU(int n) : _size(n), _timer(0), _parent(n, -1), _rank(n, 0), _time(n, INF) {}

    int root(int x) {
        return _parent[x] == -1 ? x : _parent[x] = root(_parent[x]);
    }

    bool unite(int x, int y) {
        x = root(x), y = root(y);
        if(x == y) return false;
        if (_rank[x] < _rank[y]) {
            _parent[x] = y;
            _time[x] = _timer;
        } else if (_rank[y] < _rank[x]) {
            _parent[y] = x;
            _time[y] = _timer;
        } else {
            _parent[x] = y;
            _time[x] = _timer;
            _rank[y]++;
        }
        _timer++;
        return true;
    }

    int time(int x) {
        return _time[x];
    }
};

} // namespace dsu


#endif // CFF_DSU_H




// === MAIN === 

#ifndef MAIN_H
#define MAIN_H


void solve();

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t = 1;

#ifdef MULTITEST_H
    cin >> t;
#endif // MULTITEST_H

    while (t--) {
        solve();
    }
}

#endif // MAIN_H


// === SOLVE === 


ll d[1100][1100];
ll cur[1100][1100];



void dfs(int st, int v, ll w, vector<vector<pair<int, ll>>>&g, int p = -1)
{
    cur[st][v] = w;
    for (auto e : g[v])
    {
        if (p == e.first) continue;
        dfs(st, e.first, w + e.second, g, v);
    }
}

void solve() {
    int n;  
    cin >> n;
    vector<tuple<ll,int,int>> edges;
    rep(i, n) rep (j, n) cin >> d[i][j];
    rep(i, n) rep(j, n) if(i != j) edges.emplace_back(d[i][j], i, j);
    dsu::DSU dsu(n);
    sort(all(edges));
    vector<vector<pair<int, ll>>> graph(n);
    for(auto edge : edges)
    {
        ll w = get<0>(edge);
        int u = get<1>(edge);
        int v = get<2>(edge);
        if (dsu.root(u) != dsu.root(v))
        {
            // cout << w << " "<<u <<" " << v << endl;
            dsu.unite(u, v);
            graph[u].pb(v, w);
            graph[v].pb(u, w);
        }
    }

    for (int a = 0; a < n; a++)
    {
        dfs(a, a, 0, graph);
    }
    for (int a = 0; a < n; a++)
    {
        for (int b = 0; b < n; b++)
        {
            if (d[a][b] != cur[a][b])
            {
                cout << "No\n";
                return;
            }
        }
    }
    cout << "Yes\n";
}

