def encrypt_scytale(plaintext, edges, offset=0):
    # Убираем пробелы и символы перевода строки для чистого текста
    plaintext = plaintext.replace(" ", "").replace("\n", "")
    
    # Заполняем массив символов, сгруппированных по строкам
    ciphertext = [''] * edges
    for i in range(len(plaintext)):
        row = (i + offset) % edges
        ciphertext[row] += plaintext[i]
    
    return ''.join(ciphertext)

def decrypt_scytale(ciphertext, edges, offset=0):
    # Рассчитываем длину одной строки
    n = len(ciphertext)
    cols = n // edges
    rows = n % edges
    
    # Восстанавливаем массив для дешифрования
    plaintext = [''] * n
    index = 0
    
    for row in range(edges):
        for col in range(cols + (row < rows)):
            if index < len(ciphertext):
                pos = (row + offset) % edges
                plaintext[col * edges + row] = ciphertext[index]
                index += 1
                
    return ''.join(plaintext)

# Пример использования:
plaintext = "0123456789"
edges = 2
offset = 1

ciphertext = encrypt_scytale(plaintext, edges, offset)
print("Зашифрованный текст:", ciphertext)

decrypted_text = decrypt_scytale(ciphertext, edges, offset)
print("Расшифрованный текст:", decrypted_text)
