def find(x, parents):
    if parents[x] != x:
        parents[x] = find(parents[x], parents)
    return parents[x]

def mst(matrix, n):
    edges = []
    for i in range(n):
        for j in range(i + 1, n):
            edges.append((matrix[i][j], i, j))
    edges.sort()
    parents = list(range(n))
    rank = [0] * n
    tree = []
    for x, i, j in edges:
        if find(i, parents) != find(j, parents):
            root_i = find(i, parents)
            root_j = find(j, parents)
            if rank[root_i] > rank[root_j]:
                parents[root_j] = root_i
            elif rank[root_i] < rank[root_j]:
                parents[root_i] = root_j
            else:
                parents[root_j] = root_i
                rank[root_i] += 1
            tree.append((x, i, j))
        if len(tree) == n - 1:
            break
    return tree

def calculate_distances(start, adj_matrix):
    distances = [-1] * n
    distances[start] = 0
    queue = [start]
    while queue:
        i = queue.pop()
        try:
            adj_matrix[i]
        except:
            break
        for j, w in adj_matrix[i]:
            if distances[j] == -1:
                distances[j] = distances[i] + w
                queue.append(j)

    return distances

def check(matrix, adj_matrix):
    for i in range(n):
        dist = calculate_distances(i, adj_matrix)
        for j in range(i+1, n):
            if dist[j] != matrix[i][j]:
                return "No"
    return "Yes"

n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]
tree = mst(matrix, n)
adj_matrix = {}
for x, i, j in tree:
    try:
        adj_matrix[i].append((j, x))
    except:
        adj_matrix[i] = [(j, x)]
print(check(matrix, adj_matrix))
