def is_wooden_matrix(matrix):
    n = len(matrix)

    for i in range(n):
        if matrix[i][i] != 0:
            return False
        for j in range(i + 1, n):
            if matrix[i][j] != matrix[j][i]:
                return False

    for i in range(n):
        for j in range(n):
            for k in range(n):
                if matrix[i][j] > matrix[i][k] + matrix[k][j]:
                    return False

    edges = []
    for i in range(n):
        for j in range(i + 1, n):
            if matrix[i][j] > 0:
                edges.append((matrix[i][j], i, j))

    edges.sort()
    parent = list(range(n))

    def find(x):
        if parent[x] != x:
            parent[x] = find(parent[x])
        return parent[x]

    num_edges = 0
    for length, u, v in edges:
        root_u, root_v = find(u), find(v)
        if root_u != root_v:
            parent[root_u] = root_v
            num_edges += 1
        if num_edges == n - 1:
            break

    return num_edges == n - 1


n = int(input().strip())

matrix = []
for _ in range(n):
    row = list(map(int, input().strip().split()))
    matrix.append(row)

if is_wooden_matrix(matrix) == True:
    print("Yes")
else:
    print("No")