#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;
using vl = vector<ll>;

istream &operator>>(istream &os, vl &a) {
    for (auto &x: a) cin >> x;
    return os;
}
#define int long long
const int MOD = 998244353;

struct mi {
    int v;
    explicit operator int() const { return v; }
    mi() { v = 0; }
    mi(long long _v) : v(_v % MOD) { v += (v < 0) * MOD; }
};
mi &operator+=(mi &a, mi b) {
    if ((a.v += b.v) >= MOD) a.v -= MOD;
    return a;
}
mi &operator-=(mi &a, mi b) {
    if ((a.v -= b.v) < 0) a.v += MOD;
    return a;
}
mi operator+(mi a, mi b) { return a += b; }
mi operator-(mi a, mi b) { return a -= b; }
mi operator*(mi a, mi b) { return mi((long long)a.v * b.v); }
mi &operator*=(mi &a, mi b) { return a = a * b; }
mi pow(mi a, long long p) {
    assert(p >= 0);
    return p == 0 ? 1 : pow(a * a, p / 2) * (p & 1 ? a : 1);
}
mi inv(mi a) {
    assert(a.v != 0);
    return pow(a, MOD - 2);
}
mi operator/(mi a, mi b) { return a * inv(b); }


const int N = 200200;
vector<mi> fact(N + 1, mi(1)), ifact(N + 1, mi(1));

mi C(int n, int k) {
    if (k < 0 || n < 0 || k > n) return mi(0);
    return fact[n] * ifact[n - k] * ifact[k];
}

mi start_pos(int n, int s) {
    return C(s - 1, n - 1);
}

mi start_not_neg(int n, int s) {
    return start_pos(n, s + n);
}
dwdawdawd
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);awdawdaw
    for (int i = 1; i < N; i++) fact[i] = fact[i - 1] * i;
    for (int i = 1; i < N; i++) ifact[i] = pow(fact[i], MOD - 2);
    int a, b, c;
    cin >> a >> b >> c;
    int backets = c + 1;
    mi result = 0;
    cout << C(4, 3).v << "\n";
    for (int st = XC0; st <= backets; st++) {
        mi ans = C(backets, st);
        int ost = b - st;
        if (ost < 0) continue;
        if (a < ost) continue;
        int need = ost;
        ans *= C(backets, a - ost);
        ans *= start_pos(backets, need + st);
        result += ans;
    }
    cout << result.v;

}
