// #pragma GCC optimize ("O3")
#include <bits/stdc++.h>
typedef long long ll;
// #define int ll
using namespace ::std;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define fore(collection) for (auto& val : collection)
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define dbg(v) cerr << "Line(" << __LINE__ << ") -> " << #v << " = " << (v) << endl;
#define cmax(u, v) u = max(u, v)
#define cmin(u, v) u = min(u, v)
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
template<typename ValueType>
istream& operator>>(istream& in, vector<ValueType>& vect) { fore(vect) in >> val; return in; }
template<typename ValueType>
ostream& operator<<(ostream& out, const vector<ValueType>& vect) { fore(vect) out << val << " "; return out; }


class DSU
{
public:
    DSU(size_t n) : n_(n)
    {
        vect_.reserve(n);
        forn(i, n) {
            vect_.push_back(i);
        }
    }

    // return set representative
    size_t find(size_t v)
    {
        if (v == vect_[v])
            return v;
        return vect_[v] = find(vect_[v]);
    }

    // unite set u and v
    bool unite(size_t u, size_t v)
    {
        u = find(u);
        v = find(v);
        if (u == v)
            return false;
        vect_[u] = v;
        --n_;
        return true;
    }

    // return number of component
    size_t size()
    {
        return n_;
    }
private:
    vi vect_;
    size_t n_;
};

struct Tree
{
    // Create empty tree graph with n nodes. Must be filled in before use.
    Tree(size_t n) : edges(n) {}

    // Nodes are numbered in range [1,N]
    void addEdge(size_t u, size_t v, ll d)
    {
        --u; --v;
        assert(u < edges.size() && v < edges.size());
        edges[u].push_back({v, d});
        edges[v].push_back({u, d});
    }

    vector<vector<pii>> edges;
};

struct EdgeStruct {
    int d;
    int u, v;
};

// return distance between startNode and every other node.
// if node cannot be reached, then the distance is -1
vi bfsDistance(const vector<vector<pii>>& edges, int startNode)
{
    vi dist(edges.size(), -1);
    queue<pii> q;
    q.push({startNode, 0});
    while (!q.empty()) {
        auto p = q.front();
        q.pop();
        if (dist[p.first] > -1)
            continue;
        dist[p.first] = p.second;
        fore(edges[p.first]) {
            q.push({val.first, p.second + val.second});
        }
    }
    return dist;
}

void doWork()
{
    int n;
    cin >> n;
    vvi matrix(n, vi(n));
    cin >> matrix;
    vector<EdgeStruct> vect;
    vect.reserve(n * (n - 1) / 2);
    forn(i, n) forn(j, n) {
        if (j == i)
            break;
        vect.push_back({matrix[i][j], i, j});
    }
    sort(all(vect), [](auto lhs, auto rhs){ return lhs.d < rhs.d; });
    DSU dsu(n);
    Tree tree(n);
    for (auto [d, u, v] : vect) {
        if (!dsu.unite(u, v))
            continue;
        tree.addEdge(u + 1, v + 1, d);
    }
    forn(i, n) {
        vi distanceFromI = bfsDistance(tree.edges, i);
        if (matrix[i] != distanceFromI) {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
}

signed main()
{
    srand(chrono::duration_cast<chrono::nanoseconds>(chrono::steady_clock::now().time_since_epoch()).count());
    ios_base::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        try
        {
            doWork();
        }
        catch(const std::exception& e)
        {
            std::cerr << e.what() << '\n';
            return 0;
        }
    }
    return 0;
}
