#include <iostream>
#include <vector>
#include <string>
#include <cctype>

bool check(const std::vector<std::vector<char>>& m) {
    for (const auto& row : m) {
        int accountable_count = 0;
        bool has_responsible = false;
        for (char r : row) {
            if (r == 'A') accountable_count++;
            if (r == 'R') has_responsible = true;
        }
        if (accountable_count != 1) return false;
        if (!has_responsible && accountable_count == 0) return false;
    }
    return true;
}

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    int n, m;
    std::cin >> n >> m;
    std::cin.ignore();

    std::vector<std::vector<char>> matrix(n, std::vector<char>(m));

    for (int i = 0; i < n; ++i) {
        std::string line;
        std::getline(std::cin, line);

        int col = 0;
        for (char ch : line) {
            if (std::isalpha(ch) || ch == '-') matrix[i][col++] = std::toupper(ch);
        }
    }

    if (check(matrix)) std::cout << "Yes\n";
    else std::cout << "No\n";

    return 0;
}

/*
3 5
C C A - I
A R - C I
A R I C -


3 3
A - C
R C I
- A I
*/