#include <bits/stdc++.h>

#define pb push_back

using namespace std;

int n;
vector<vector<long long>> d, s;
vector<vector<int>> adj;
vector<int> visited;
vector<long long> p;

void dfs(int u) {
    visited[u] = 1;
    for (int v : adj[u]) {
        if (!visited[v]) {
            p[v] = p[u] + d[u][v];
            dfs(v);
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
#endif
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
    cin >> n;
    d.resize(n, vector<long long>(n));
    s.resize(n, vector<long long>(n, 1e18));
    adj.resize(n);
    visited.resize(n, 0);
    p.resize(n, 0);
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            cin >> d[i][j];
    for (int i = 0; i < n; ++i) {
        if (d[i][i] != 0) {
            cout << "No";
            return 0;
        }
        for (int j = 0; j < n; ++j) {
            if (d[i][j] != d[j][i] || (i != j && d[i][j] <= 0)) {
                cout << "No";
                return 0;
            }
        }
    }
    for (int k = 0; k < n; ++k)
        for (int i = 0; i < n; ++i)
            if (i != k)
                for (int j = 0; j < n; ++j)
                    if (j != k && i != j)
                        if (d[i][k] + d[k][j] < s[i][j])
                            s[i][j] = d[i][k] + d[k][j];
    vector<vector<int>> edge(n, vector<int>(n, 1));
    for (int i = 0; i < n; ++i)
        edge[i][i] = 0;
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            if (i != j && d[i][j] >= s[i][j])
                edge[i][j] = 0;
    int edges = 0;
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
            if (edge[i][j] && edge[j][i]) {
                adj[i].push_back(j);
                adj[j].push_back(i);
                ++edges;
            }
    if (edges != n - 1) {
        cout << "No";
        return 0;
    }
    dfs(0);
    for (int i = 0; i < n; ++i)
        if (!visited[i]) {
            cout << "No";
            return 0;
        }
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < n; ++j)
            if (abs(p[i] - p[j]) != d[i][j]) {
                cout << "No";
                return 0;
            }
    cout << "Yes";
    return 0;
}