#include <bits/stdc++.h>
using namespace std;

//#define INTERACTIVE

#define ll long long
#define ld long double
#define F first
#define S second
#define pb push_back

#define int ll

// #pragma GCC optimize("Ofast")

int toint(const string &s) {
    int ans = 0;
    for (const char c : s) {
        if ('0' <= c && c <= '9') {
            ans = ans * 10 + (c - '0');
        }
    }
    return ans;
}

struct transfer {
    int from, to, line;
};

struct iterationResult {
    int to;
    int ops;
};

map<int, iterationResult> byFrom;
map<int, iterationResult> byLine;

set<pair<int, int>> transfersIndex;

vector<transfer> transfers;

void calcLine(int line) {
    if (byLine.count(line)) {
        return;
    }

    int x = transfers[line].to;
    int ops = 2;
    for (int nextLine = line+1; nextLine < transfers.size(); nextLine++) {
        if (transfers[nextLine].from == x) {
            calcLine(nextLine);
            x = byLine[nextLine].to;
            ops += byLine[nextLine].ops;
            break;
        } else {
            ++ops;
        }
    }

    byLine[line] = iterationResult{x, ops};
}

iterationResult calcIteration(const transfer &t) {
    if (byLine.count(t.line)) {
        return {byLine[t.line].to, byLine[t.line].ops + t.line};
    }
    int ops = 2; // if (i == t.from) i = t.to;
    ops += t.line; // все предыдущие if'ы, в которые он не вошел
    int x = t.to;
    int lastLine = t.line;
    while (true) {
        auto nextLine = transfersIndex.lower_bound({x, lastLine+1});
        if (nextLine == transfersIndex.end() || nextLine->first != x) {
            ops += transfers.size() - lastLine - 1;
            break;
        }

        ops += nextLine->second - lastLine - 1;
        calcLine(nextLine->second);
        x = byLine[nextLine->second].to;
        ops += byLine[nextLine->second].ops;
        break;
    }

    byLine[t.line] = iterationResult{x, ops};
    return byLine[t.line];
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
#ifndef INTERACTIVE
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);
    #define endl '\n'
#endif
#endif
    string s;
    getline(cin, s, ' '); // for
    // cerr << s << endl;
    getline(cin, s, ' '); // (int
    // cerr << s << endl;
    getline(cin, s, ' '); // i
    // cerr << s << endl;
    getline(cin, s, ' '); // =
    // cerr << s << endl;
    getline(cin, s, ' '); // 0;
    // cerr << s << endl;
    getline(cin, s, ' '); // i
    // cerr << s << endl;
    getline(cin, s, ' '); // <
    // cerr << s << endl;
    getline(cin, s, ' '); // UPPER_BOUND;
    // cerr << "upperBound = " << s << endl;
    int upperBound = toint(s);
    getline(cin, s); // i++) {
    // cerr << s << endl;
    for(int line = 0; ; ++line) {
        getline(cin, s, '('); // if || work
        if (s == "    work ") {
            break;
        }
        getline(cin, s, ' '); // i
        getline(cin, s, ' '); // ==
        getline(cin, s, ' '); // FROM)
        int from = toint(s);
        getline(cin, s, ' '); // i
        getline(cin, s, ' '); // =
        getline(cin, s); // TO;
        int to = toint(s);
        transfers.pb({from, to, line});
        transfersIndex.insert({from, line});
    }
    // for (auto to : transfers) {
    //     cout << to.from << " " << to.to << " " << to.line << endl;
    // }

    int defaultIterationOps = transfers.size() + 3; // ifs + work + (i++) + (i < upperBound)

    for (auto &to : transfers) {
        if (byFrom.count(to.from)) {
            continue;
        }
        byFrom[to.from] = calcIteration(to);
    }

    int ops = 2;
    set<int> visitedTransfers;
    for (int i = 0; i < upperBound; ++i) {
        // cerr << i << endl;
        auto nextIf = byFrom.lower_bound(i);
        if (nextIf == byFrom.end() || nextIf->F >= upperBound) {
            ops += defaultIterationOps * (upperBound - i);
            break;
        }
        ops += defaultIterationOps * (nextIf->F - i);
        ops += nextIf->S.ops + 3;
        if (visitedTransfers.count(nextIf->F)) {
            cout << -1 << endl;
            return 0;
        }
        i = nextIf->S.to;
        visitedTransfers.insert(nextIf->F);
    }

    cout << ops << endl;

    // for (auto &to : byFrom) {
    //     cout << "if i = " << to.first << ", work will be called with i = " << to.second.to << " and " << to.second.ops << " operations will be needed" << endl;
    // }
}