#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

bool isValidRACIMatrix(int n, int m, const vector<vector<char> >& matrix) {
    for (int i = 0; i < n; i++) {
        int accountableCount = 0;
        bool hasResponsible = false;

        for (int j = 0; j < m; j++) {
            char level = matrix[i][j];

            if (level == 'A' || level == 'a') {
                accountableCount++;
            } else if (level == 'R' || level == 'r') {
                hasResponsible = true;
            }
        }

        if (accountableCount != 1) {
            return false;
        }

        if (!hasResponsible && accountableCount == 0) {
            return false;
        }
    }

    return true;
}

int main() {
    int n, m;
    cin >> n >> m;

    vector<vector<char> > matrix(n, vector<char>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> matrix[i][j];
            matrix[i][j] = toupper(matrix[i][j]); 
        }
    }

    if (isValidRACIMatrix(n, m, matrix)) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }

    return 0;
}

