#include <iostream>
#include <vector>
#include <iomanip>

using namespace std;

struct Point {
    int x, y;
};

double calculateTriangleArea(int base, int height) {
    return 0.5 * base * height;
}

int main() {
    int n;
    cin >> n;
    vector<Point> points(n);
    vector<Point> pointsOnX;

    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
        if (points[i].y == 0) {
            pointsOnX.push_back(points[i]);
        }
    }

    double maxArea = 0.0;

    for (size_t i = 0; i < pointsOnX.size(); ++i) {
        for (size_t j = i + 1; j < pointsOnX.size(); ++j) {
            int base = abs(pointsOnX[i].x - pointsOnX[j].x);
            int maxHeight = 0;

            for (const Point& p : points) {
                if (p.y > 0) {
                    maxHeight = max(maxHeight, p.y);
                }
            }

            for (const Point& p : points) {
                if (p.y < 0) {
                    maxHeight = max(maxHeight, -p.y);
                }
            }

            double area = calculateTriangleArea(base, maxHeight);
            maxArea = max(maxArea, area);
        }
    }

    cout << fixed << setprecision(9) << maxArea << endl;

    return 0;
}
