﻿#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>

using namespace std;

// Функция для нахождения максимальной площади треугольника
double maxTriangleArea(const vector<pair<int, int>>& points) {
    vector<pair<int, int>> pointsOnOX;

    // Находим точки, которые расположены на оси OX
    for (const auto& point : points) {
        if (point.second == 0) {
            pointsOnOX.push_back(point);
        }
    }

    int k = pointsOnOX.size();
    if (k < 2) {
        // Если недостаточно баз треугольника, площадь будет 0
        return 0.0;
    }

    double maxArea = 0.0;

    // Перебираем все пары точек на оси OX
    for (int i = 0; i < k; i++) {
        for (int j = i + 1; j < k; j++) {
            double baseLength = abs(pointsOnOX[j].first - pointsOnOX[i].first);
            double maxHeight = 0.0;

            // Ищем максимальную высоту для текущей базы
            for (const auto& point : points) {
                if (point.second > 0 &&
                    point.first > min(pointsOnOX[i].first, pointsOnOX[j].first) &&
                    point.first < max(pointsOnOX[i].first, pointsOnOX[j].first)) {
                    maxHeight = max(maxHeight, static_cast<double>(point.second));
                }
            }

            // Вычисляем площадь треугольника и обновляем максимальную площадь если нужно
            double area = 0.5 * baseLength * maxHeight;
            maxArea = max(maxArea, area);
        }
    }

    return maxArea;
}

int main() {
    int n;
    cin >> n;

    vector<pair<int, int>> points(n);
    for (int i = 0; i < n; i++) {
        cin >> points[i].first >> points[i].second;
    }

    // Вызываем функцию для нахождения максимальной площади треугольника
    double result = maxTriangleArea(points);

    // Выводим результат
    cout << result << endl;

    return 0;
}