#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool isWoodenMatrix(const vector<vector<int>>& matrix, int n) {
    long long totalSum = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            totalSum += matrix[i][j];
        }
    }

    for (int i = 0; i < n; ++i) {
        long long rowSum = 0;
        for (int j = 0; j < n; ++j) {
            if (i != j) {
                rowSum += matrix[i][j];
            }
        }
        if (rowSum * 2 != totalSum) {
            return false;
        }
    }
    return true;
}

int main() {
    int n;
    cin >> n;

    vector<vector<int>> matrix(n, vector<int>(n));

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> matrix[i][j];
        }
    }

    if (isWoodenMatrix(matrix, n)) {
        cout << "Yes" << endl;
    } else {
        cout << "No" << endl;
    }

    return 0;
}