from itertools import combinations


def square(x1, x2, x3, y1, y2, y3):
    return 0.5 * abs((x2 - x1)*(y3 - y1) - (x3 - x1)*(y2 - y1))


def main():
    n = int(input())
    points = list()
    for _ in range(n):
        points.append(tuple(map(int, input().split())))

    ox_points = [point for point in points if point[1] == 0]
    outside_ox_points = [point for point in points if point[1] != 0]

    max_square = 0
    for ox_pair in combinations(ox_points, 2):
        for outside_ox_point in outside_ox_points:
            triplet = (*ox_pair, outside_ox_point)
            max_square = max(max_square, square(x1=triplet[0][0], x2=triplet[1][0], x3=triplet[2][0], y1=triplet[0][1], y2=triplet[1][1], y3=triplet[2][1]))

    print(max_square)

    
if __name__ == "__main__":
    main()