n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]

def check_triangle_inequality():
    for i in range(n):
        for j in range(n):
            for k in range(n):
                if matrix[i][j] > matrix[i][k] + matrix[k][j]:
                    return False
    return True
  
def check_mst_sum():
    edges = []
    total_sum = 0
    for i in range(n):
        for j in range(i + 1, n):
            edges.append((matrix[i][j], i, j))
            total_sum += matrix[i][j]
    edges.sort()
    parent = list(range(n))
    def find(x):
        if parent[x] != x:
            parent[x] = find(parent[x])
        return parent[x]
    def union(x, y):
        rootX = find(x)
        rootY = find(y)
        if rootX != rootY:
            parent[rootY] = rootX
    mst_sum = 0
    edge_count = 0
    for weight, u, v in edges:
        if find(u) != find(v):
            union(u, v)
            mst_sum += weight
            edge_count += 1
            if edge_count == n - 1:
                break
    return mst_sum == total_sum // 2

if check_triangle_inequality() and check_mst_sum():
    print("Yes")
else:
    print("No")
