#include <cstdint>
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <ios>


std::string solve(std::string &s, std::int64_t k)
{
	std::vector<std::pair<char, std::int64_t>> order(s.size());

	for (std::size_t i = 0; i < order.size(); ++i)
	{
		order[i] = {s[i], i};
	}

	std::sort(order.begin(), order.end(), [] (const auto &a, const auto &b)
	{
		if (a.first == b.first)
		{
			return a.second < b.second;
		}

		return a.first < b.first;
	});

	std::int64_t insert_position = 0;
	std::int64_t start = 0;

	for (std::size_t i = 0; i < order.size(); ++i)
	{
		const auto &[digit, position] = order[i];

		if (position > 0 && s[position - 1] <= s[position])
		{
			continue;
		}

		std::int64_t rev_size = std::min(k, position - insert_position);
		start = position - rev_size;
		k -= rev_size;

		std::reverse(s.begin() + start, s.begin() + position);
		std::reverse(s.begin() + start, s.begin() + position + 1);

		if (k == 0)
		{
			break;
		}
	}

	return s;
}


int main()
{
	std::ios_base::sync_with_stdio(false);
	std::int64_t t;
	std::string s;
	std::int64_t k;


	std::cin >> t;
	for (std::int64_t i = 0; i < t; ++i)
	{
		std::cin >> s >> k;
		std::cout << solve(s, k) << '\n';
	}

	return 0;
}
