#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

const int MOD = 998244353;
const int MAXN = 100005;

long long factorial[MAXN], inv_factorial[MAXN];


long long mod_pow(long long x, long long y) {
    long long res = 1;
    x %= MOD;
    while (y) {
        if (y & 1)
            res = res * x % MOD;
        x = x * x % MOD;
        y >>= 1;
    }
    return res;
}


int main() {
    factorial[0] = inv_factorial[0] = 1;
    for (int i = 1; i < MAXN; i++) {
        factorial[i] = factorial[i - 1] * i % MOD;
        inv_factorial[i] = mod_pow(factorial[i], MOD - 2);
    }

    int r, g, b;
    cin >> r >> g >> b;

    vector<int> counts = {r, g, b};
    sort(counts.begin(), counts.end(), greater<int>());

    long long c1 = counts[0], c2 = counts[1], c3 = counts[2];
    long long N = c1 + c2 + c3;

    if (c1 > c2 + c3 + 1) {
        cout << 0 << endl;
        return 0;
    } else if (c1 == c2 + c3 + 1) {
        cout << 2 << endl;
        return 0;
    }

    long long total_perms = factorial[N];
    total_perms = total_perms * inv_factorial[r] % MOD;
    total_perms = total_perms * inv_factorial[g] % MOD;
    total_perms = total_perms * inv_factorial[b] % MOD;

    if (c1 == c2 && c2 == c3) cout << total_perms << endl;
    else cout << total_perms * mod_pow(2, MOD - 2) % MOD << endl;

    return 0;
}
