#include <iostream>

#define int long long

using namespace std;

int MAX = 9000000000000000000;

struct Node{
    int key, prior, size = 1, MIN = MAX;
    Node *l, *r;
    Node(int _key){
        key = _key;
        prior = rand();
        MIN = _key;
        l = r = nullptr;
    }
};

int size(Node *v){
    return v ? v->size : 0;
}

int min(Node *v){
    if (v != nullptr) {
        return v->MIN;
    }
    return MAX;
}

void upd(Node* v){
    v->size = 1 + size(v->l) + size(v->r);
    v->MIN = min(min(v->l), min(v->key, min(v->r)));
}

typedef pair < Node*, Node* > Pair;

Pair split(Node *p, int k){
    if (!p) return {0, 0};
    if (size(p->l) + 1 <= k){
        Pair q = split(p->r, k - size(p->l) - 1);
        p->r = q.first;
        upd(p);
        return {p, q.second};
    } else{
        Pair q = split(p->l, k);
        p->l = q.second;
        upd(p);
        return {q.first, p};
    }
}

Node* merge(Node* l, Node* r){
    if (l == nullptr) return r;
    if (r == nullptr) return l;
    if (l->prior > r->prior){
        l->r = merge(l->r, r);
        upd(l);
        return l;
    } else{
        r->l = merge(l, r->l);
        upd(r);
        return r;
    }
}

Node* root = nullptr;

Pair ctrlx (Node* v, int l, int r){
    Pair q1 = split(v, r);
    Pair q2 = split(q1.first, l);
    v = merge(q2.first, q1.second);
    return {q2.second, v};
}

int find(Node *v, int x) {
    if (v->l != nullptr && v->l->MIN == x) {
        return find(v->l, x);
    }
    if (v->key == x) {
        return size(v->l);
    }
    if (v->r != nullptr && v->r->MIN == x) {
        return find(v->r, x) + size(v->l) + 1;
    }
    return 0;
}

signed main(){
    int t, k;
    string s;
    cin >> t;
    while (t--){
        root = nullptr;
        cin >> s >> k;
        for (char c : s){
            int val = c - '0';
            Node* newnode = new Node(val);
            root = merge(root, newnode);
        }
        int n = s.size();
        for (int i = 0; i < n; i++){
            auto res= ctrlx(root, 0,min(size(root), k + 1));
            Node *tree = res.first;
            root = res.second;
            int MINVALUE = min(tree);
            int pos = find(tree, MINVALUE);
            tree = ctrlx(tree, pos, pos + 1).second;
            root = merge(tree, root);
            cout << MINVALUE;
            k -= pos;
        }
        cout << '\n';
    }
}