#include <iostream>
#include <string>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <set>
#include <random>
#include <cstring>
#include <numeric>
#include <queue>
#include <cassert>
#include <fstream>
#include <sstream>
#include <bitset>
#include <deque>
#include <complex>
#include <iterator>
#include <stack>

using namespace std;

#define M_PI 3.14159265358979323846264338327950288419716939937510
#define inf 1e18
#define eps 1e-5
#define fori(n)for (long long i = 0; i < (n); i++)
#define forj(n)for (long long j = 0; j < (n); j++)
#define rep(i, n)for (long long i = 0; i < (n); i++)
#define re return
#define ll long long
#define ull unsigned long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define bit(i, n) (((n) >> (i)) & 1)
#define ld long double
#define vec vector
#define unq(x) x.resize(unique(all(x)) - x.begin())

int __not_lg(ll n) { int cnt = 0; while (n /= 2) cnt++; re cnt; }
int __popcnt(ll n) { int ans = 0; while (n) {ans += n % 2; n >>= 1;} re ans; }

#define __lg(n) __not_lg(n)
#ifdef LOCAL_BOBER
//#define __builtin_popcountll(n) __popcnt(n)
#define ffast_io ios::sync_with_stdio(false);\
                 cout.tie(nullptr)
#else
#define ffast_io ios::sync_with_stdio(false);\
                 cout.tie(nullptr); cin.tie(nullptr)
#endif

template<class T> T fast_pow(T n, ll p) { if (p == 0) re (T)1; if (p % 2) re n* fast_pow(n, p - 1); re fast_pow(n * n, p / 2); }
template<class T> T mod_fast_pow(T n, T p, T m) { if (p == 0) re(T)1; if (p % 2 == 1) re n* mod_fast_pow(n, p - 1, m) % m; re mod_fast_pow(n * n % m, p / 2, m); }
template<class T> T gcd(T a, T b) { if (!a)re b; re gcd(b % a, a); }
template<class T> void umax(T& a, T b) { a = max(a, b); }
template<class T> void umin(T& a, T b) { a = min(a, b); }
template<class T, class U> istream& operator >> (istream& o, pair<T, U>& x) { o >> x.first >> x.second; re o; }
template<class T> istream& operator >> (istream& o, pair<T, T>& x) { o >> x.first >> x.second; re o; }
template<class T> istream& operator >> (istream& o, vector<T>& x) { for (auto& el : x) o >> el; re o; }
template<class T, class U> pair<T, U> operator-(pair<T, U> a, pair<T, U> b) { return { a.first - b.first, a.second - b.second }; }
template<class T, class U> pair<T, U> operator+(pair<T, U> a, pair<T, U> b) { return { a.first + b.first, a.second + b.second }; }
template<class T> vector<T> operator+(vector<T> a, vector<T> b) { fori(a.size())a[i] += b[i]; re a; }
template<class T> vector<T> operator-(vector<T> a, vector<T> b) { fori(a.size())a[i] -= b[i]; re a; }
template<class T> string to_bin(T n) { string s = ""; while (n) { s = to_string(n % 2) + s; n >>= 1; } re s; }
template<class T> string fixed_to_bin(T n, ll q) { string s = "";  fori(q) { s = to_string(n % 2) + s; n >>= 1; } re s; }
ll from_bin(string s) { ll m = 0; fori(s.size()) { m = (m * 2) + s[i] - '0'; } re m; }
template<class T> int cnt_bit(T n) { int cnt = 0; while (n) { cnt += n % 2; n >>= 1; }re cnt; }
struct dsu {
    vector<int> v, cnt;
    void build(int n) { v.resize(n); cnt.resize(n); iota(all(v), 0); fill(all(cnt), 1); }
    dsu() {}
    dsu(int n) { build(n); }
    int get_par(int i) { if (v[i] != i)v[i] = get_par(v[i]); re v[i]; }
    bool check(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); re i1 == i2; }
    void merge(int i1, int i2) { i1 = get_par(i1), i2 = get_par(i2); if (i1 == i2)re; if (cnt[i1] > cnt[i2])swap(i1, i2); cnt[i1] += cnt[i2]; v[i2] = i1; }
};
using comp = complex<double>;
const double PI = acos(-1);
void fft(vector<comp> &a, vector<comp> &r, ll n, comp x, ll ab, ll astep, ll rb) {
    if (n == 1) {
        r[rb] = a[ab];
        return;
    }
    fft(a, r, n / 2, x * x, ab, astep * 2, rb);
    fft(a, r, n / 2, x * x, ab + astep, astep * 2, rb + n / 2);
    comp w = 1;
    for (ll i = rb; i < rb + n / 2; i++) {
        comp c = r[i], d = r[i + n / 2];
        r[i] = c + d * w;
        r[i + n / 2] = c - d * w;
        w *= x;
    }
}
vector<ll> fft_mult(vector<ll> &A, vector<ll> &B) {
    vector<comp> a(A.begin(), A.end()), b(B.begin(), B.end());
    ll n = a.size() + b.size();
//    while (__builtin_popcount(n) != 1) { n++; }
    while (a.size() != n) a.push_back(0);
    while (b.size() != n) b.push_back(0);
    vector<comp> ra(n), rb(n);
    comp x = comp(cos(2 * PI / n), sin(2 * PI / n));
    fft(a, ra, n, x, 0, 1, 0);
    fft(b, rb, n, x, 0, 1, 0);
    vector<comp> rab(n);
    for (ll i = 0; i < n; i++) rab[i] = ra[i] * rb[i] / comp(n);
    x = comp(cos(2 * PI / n), -sin(2 * PI / n));
    vector<comp> c(n);
    fft(rab, c, n, x, 0, 1, 0);
    vector<ll> cc(n);
    for (ll i = 0; i < n; i++)cc[i] = round(c[i].real());
    return cc;
}
/*
    ___        __              __   ______          __        _____ __             __          __  __
   /   | _____/ /___  ______ _/ /  / ____/___  ____/ /__     / ___// /_____ ______/ /______   / / / /__  ________
  / /| |/ ___/ __/ / / / __ `/ /  / /   / __ \/ __  / _ \    \__ \/ __/ __ `/ ___/ __/ ___/  / /_/ / _ \/ ___/ _ \
 / ___ / /__/ /_/ /_/ / /_/ / /  / /___/ /_/ / /_/ /  __/   ___/ / /_/ /_/ / /  / /_(__  )  / __  /  __/ /  /  __/
/_/  |_\___/\__/\__,_/\__,_/_/   \____/\____/\__,_/\___/   /____/\__/\__,_/_/   \__/____/  /_/ /_/\___/_/   \___/

*///coating_len

mt19937 rd(1993719937);

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,tune=native")

#define int ll

void rot(int l, int r, string& s) {
    for (int i = r; i > l; --i) {
        swap(s[i], s[i - 1]);
    }
}

struct seg_tree {
    vec<ll> v;
    ll add;

    void build(ll n) {
        add = (1ll << (__lg(n - 1) + 1));
        v.resize(add * 2);
    }

    void upd(int l, int r, int x) {
        l += add;
        r += add;

        while (l <= r) {
            if (l % 2 == 1) v[l] += x;
            if (r % 2 == 0) v[r] += x;

            l = (l + 1) / 2;
            r = (r - 1) / 2;
        }
    }

    int get(int i) {
        i += add;
        int ans = 0;
        while (i) {
            ans += v[i];
            i >>= 1;
        }
        re ans;
    }
};

void f(string& s, int k, int i, vec<queue<int>>& v, seg_tree& tree) {
    if (i == s.size()) re;

    for (int j = (i == 0); j < 10; ++j) {
        if (v[j].empty() || v[j].front() + tree.get(v[j].front()) - i > k) continue;
//        cout << i << " " << j << " " << v[j].front() << " " << tree.get(v[j].front()) << " " << k << endl;

        int pp = v[j].front();
        v[j].pop();
        s[i] = j + '0';

        tree.upd(0, pp, 1);
        f(s, k - (pp + tree.get(pp) - i - 1), i + 1, v, tree);

        re;
    }
}

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int t; cin >> t;
    while (t--) {
        string s; cin >> s;
        int k; cin >> k;

        vec<queue<int>> pos(10);
        fori(s.size()) {
            pos[s[i] - '0'].push(i);
        }

        seg_tree tree;
        tree.build(s.size());


        f(s, k, 0, pos, tree);
        cout << s << "\n";
    }
}