#include <algorithm>
#include <iomanip>
#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;
typedef long double ld;

ll bin_pow(ll a, ll n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return bin_pow(a, n - 1) * a;
    ll b = bin_pow(a, n / 2);
    return b * b;
}

ll gcd(ll a, ll b) {
    while (a && b) {
        if (a > b) a %= b;
        else b %= a;
    }
    return a + b;
}

struct point {
    ll x, y;
};

point get(point a, point b) {
    return {b.x - a.x, b.y - a.y};
}

ll operator*(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

struct st {
    int m, l, r;
};

void solve() {
    int n, nprev; cin >> n;
    nprev = n;
    vector <int> a(n), ar, an;
    for (int i = 0; i < n; i++) cin >> a[i];
    int s, f;cin >> s >> f;s--,f--;
    for (int i = min(s, f); i <= max(s, f); i++) {
        an.push_back(a[i]);
    }
    a = an;
    ar.resize(a.size());
    n = a.size();
    bool isr = 0;
    if (s > f) {
        isr = 1;
        swap(s, f);
        reverse(a.begin(), a.end());
    }
    for (int i = 0; i < n - 1; i++) {
        ar[i] = abs(a[i + 1] - a[i]);
        if (ar[i] == 1) {
            cout << "Impossible";
            return;
        }
    }
    vector <st> ans;
    for (int i = 0; i < n - 1;) {
        int curgcd = 0, iprev = i;
        while (i < n - 1 && gcd(curgcd, ar[i]) != 1) {
            curgcd = gcd(curgcd, ar[i]);
            i++;
        }
        if (curgcd == 0) {
            curgcd = 2;
        }
        ans.push_back({curgcd, iprev, i});
    }
    for (int i = 0; i < ans.size(); i++) {
        cout << "Kaban-" << ans[i].m << ' ';
        if (!isr) cout << ans[i].l + s + 1 << ' ' << ans[i].r + s + 1 << "\n";
        else {
            cout << n - ans[i].l + s << ' ' << n - ans[i].r + s << "\n";
        }
    }
}

int main() {
    int t = 1;
    //cin >> t;
    while (t--) solve();
}
