#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define repi(i,a,b) for (int i = a; i < b; i++)
#define each(i, a) for (auto&i: a)
#define all(a) a.begin(), a.end()
#define sz(a) (ll) a.size()

using ll = long long;
using pll = pair<ll, ll>;
using vi = vector<ll>;
using vvi = vector<vi>;

struct Node {
    ll sum = 0;
    bool is_leaf = false;
    Node() {}
};

struct segTree {
    vector<Node> tree;
    segTree(ll n) {
        tree.assign(4 * n, Node());
    }

    void push(ll v) {
        if (!tree[v].is_leaf) {
            tree[2 * v].sum += tree[v].sum;
            tree[2 * v + 1].sum += tree[v].sum;
            tree[v].sum = 0;
        }
    }

    void build(ll v, ll l, ll r) {
        if (l == r) {
            tree[v].is_leaf = true;
            return;
        }
        ll m = (l + r) / 2;
        build(2 * v, l, m);
        build(2 * v + 1, m + 1, r);
    }

    void update(ll v, ll tl, ll tr, ll l, ll r, ll val) {
        if (tr < l || tl > r) return;
        push(v);
        if (tl >= l && tr <= r) {
            tree[v].sum += val;
            return;
        }
        ll m = (tl + tr) >> 1;
        update(2 * v, tl, m, l, r, val);
        update(2 * v + 1, m + 1, tr, l, r, val);
    }

    ll get(ll v, ll tl, ll tr, ll pos) {
        push(v);
        if (tl == tr) {
            return tree[v].sum;
        }
        ll m = (tl + tr) >> 1;
        if (pos <= m) return get(2 * v, tl, m, pos);
        return get(2 * v + 1, m + 1, tr, pos);
    }
};

mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());

void solve() {
    string s; cin >> s;
    int k; cin >> k;
    int n = s.size();

    vector<deque<int>> ls(10);
    for (int i = 0; i < s.size(); i++) {
        ls[s[i] - '0'].push_back(i);
    }

    string ans = "";
    segTree shift = segTree(n);
    shift.build(1, 0, n - 1);

    for (int i = 0; i < n; i++) {
        int digit = -1;
        for (int j = 9; j >= 0; j--) {
            int p = ls[j][0] + shift.get(1, 0, n - 1, ls[j][0]);
            if (!ls[j].empty() && p - i <= k) digit = j;
        }
        ans += char('0' + digit);
        int pos = ls[digit][0] + shift.get(1, 0, n - 1, ls[digit][0]);
        int diff = pos - i;
        if (diff != 0) {
            shift.update(1, 0, n - 1, 0, pos - 1, 1);
            ls[digit].pop_front();
            k -= diff;
        }
        for (int j = 0; j < 10; j++) {
            while (ls[j].size() && ls[j][0] + shift.get(1, 0, n - 1, ls[j][0]) <= i) ls[j].pop_front();
        }
    }
    cout << ans << '\n';
}


int main() {
    // freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}