#include <algorithm>
#include <bitset>
#include <cctype>
#include <cstdio>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <math.h>
#include <numeric>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <unordered_map>
#include <vector>
using namespace std;
#define int long long
#define M9 2286661337LL
#define mod 998244353
#define INF (M9 * M9)
#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define eps 1e-6

// mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
// int get_rnd(int l, int r) { return rnd() % (r - l + 1) + l; }

int first_m, second_m;
map<int, int> mp;
map<int, int> rev_mp;

int get_num(string &s) {
  int res = 0;
  for (int i = 0; i < 7; i++) {
    res *= 2;
    res += (s[i] - '0');
  }
  return res;
}

pair<int, int> and_mask(int a) {
  int dec = a / 10;
  int rem = a % 10;

  if (dec == 0) {
    return {-1, mp[rem] & second_m};
  } else {
    return {mp[dec] & first_m, mp[rem] & second_m};
  }
}

int num_from_mask(const pair<int, int> &a) {
  if (a.first == -1) {
    return rev_mp[a.second];
  } else {
    return rev_mp[a.first] * 10 + rev_mp[a.second];
  }
}

void solve() {

  mp[0] = 119; mp[1] = 18; mp[2] = 93; mp[3] = 91;
  mp[4] = 58; mp[5] = 107; mp[6] = 111; mp[7] = 82;
  mp[8] = 127; mp[9] = 123;

  for (auto &[x, y] : mp) {
    rev_mp[y] = x;
  }

  for (int i = 0; i < 256; i++) {
    if (rev_mp.count(i))
      continue;
    rev_mp[i] = M9;
  }

  string a, b;
  cin >> a >> b;

  first_m = get_num(a);
  second_m = get_num(b);

  int ans = 0;
  for (int i = 1; i <= 99; i++) {

    int in_mask = num_from_mask(and_mask(i));
    if (in_mask >= M9) {
      continue;
    }
    int temp = 0;
    for (int k = i - 1; k > 0; k--) {
      int delta = i - k;
      int cur = num_from_mask(and_mask(k));
      if (cur >= M9)
        break;

      if (in_mask + delta == cur) {
        temp++;
      }
    }
    ans = max(ans, temp);
  }
  std::cout << ans;
}

signed main() {
#ifdef LOCAL_ARTEM
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  cout.tie(0);

  int t = 1;
  //  cin >> t;
  while (t--)
    solve();

#ifdef LOCAL_ARTEM
  cout << '\n'
       << fixed << setprecision(3) << 1. * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
  return 0;
}
