// #pragma GCC optimize ("Ofast,unroll-loops")
// #pragma GCC target ("avx2,fma")

// #define local

#ifdef local
#include"stdc++.h"
#else
#include<bits/stdc++.h>
#endif

using namespace std;

#define forx(i, a, b) for (int (i) = a; (i) < (b); (i)++)
#define INF int(1e9+1)
#define all(x2) begin(x2),end(x2)
#define isz(t) ((int)(t.size()))
#define last(x) (*(x.end()-1))
#define ft first
#define sd second
#define pr pair
#define sh(x)  cerr<<#x<<" = "<<x<<'\n'
//#define debug(x) std::cout << #x << " = " << x << std::endl

string to_string(string s) {
    return s;
}

template<typename ... T>
std::ostream &operator<<(std::ostream &, const std::vector<T...> &);

template<typename Iterator>
std::ostream &print(std::ostream &os, Iterator begin, Iterator end) {
    os << "{";
    bool isFirst = true;
    for (auto it = begin; it != end; it++) {
        if (!isFirst) os << ", ";
        isFirst = false;
        os << *it;
    }
    return os << "}";
}

template<typename ... T>
std::ostream &operator<<(std::ostream &os, const std::vector<T...> &vec) {
    return print(os, vec.begin(), vec.end());
}

template<typename ...Args>
void show(Args &&... args) {
    (std::cerr << ... <<(to_string(args) + " ")) << '\n';
}

template<typename ...Args>
void printer(Args &&... args) {
    (std::cout << ... <<(to_string(args) + " ")) << '\n';
}

template<typename T, typename... Args>
void push_back_vec(std::vector<T> &v, Args &&... args) {
    (v.push_back(std::forward<Args>(args)), ...);
}

template<class ...Args>
void input(Args &... args) {
    (cin>>...>>args);
}

template<typename T>
T minimum(T x) {
    return x;
}

template<typename T, typename... Pack>
auto minimum(T x, Pack... p) {
    using common = typename std::common_type<T, Pack...>::type;
    return std::min((common) x, (common) minimum(p...));
}

template<typename T>
T maximum(T x) {
    return x;
}

template<typename T, typename... Pack>
auto maximum(T x, Pack... p) {
    using common = typename std::common_type<T, Pack...>::type;
    return std::max((common) x, (common) maximum(p...));
}

#define int int64_t
#define mod int64_t(1e9 + 7)

using ll = int64_t;
using ld = long double;
using ull = unsigned long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using pd = pair<ld, ld>;
using vi = vector<int>;
using vl = vector<ll>;
using vd = vector<ld>;
using vb = vector<bool>;
using vpi = vector<pi>;
using vpl = vector<pl>;
using vpd = vector<pd>;

template <typename T>
void gauss(std::vector<std::vector<T>> &a, std::vector<T> &b)
{
    const int n = (int)a.size();
    assert((int)a[0].size() == n);
    assert((int)b.size() == n);
    // решаем СЛАУ
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (i != j)
            {
                T coeff = (a[j][i] / a[i][i]);
                for (int k = i; k < n; k++)
                    a[j][k] -= a[i][k] * coeff;
                b[j] -= coeff * b[i];
            }
    // находим ответ:
    for (int i = 0; i < n; i++)
        b[i] /= a[i][i];
}

template<class T>
struct SQRT {
    vector<T> data;
    vector<T> inpt;
    int len = 256; // и размер блока, и количество блоков
    T default_val = 0;

    T operation(T a, T b) {
        return a + b;
    }

    SQRT(vector<T>& inpt_data){
        inpt = inpt_data;
        int n = isz(inpt);
        len = (int) sqrt (n + .0) + 1;
        data = vector<T>(len, default_val);
        for (int i=0; i<n; ++i)
	        data[i / len] = operation(data[i / len], inpt[i]);
    }

    T get(int l, int r) {
        int res = default_val;
        int c_l = l / len,   c_r = r / len;
        if (c_l == c_r)
            for (int i=l; i<=r; ++i)
                res = operation(res, inpt[i]);
        else {
            for (int i=l, end=(c_l+1)*len-1; i<=end; ++i)
                res = operation(res, inpt[i]);
            for (int i=c_l+1; i<=c_r-1; ++i)
                res = operation(res, data[i]);
            for (int i=c_r*len; i<=r; ++i)
                res = operation(res, inpt[i]);
        }
        return res;
    }
};

#define debug

#ifndef debug
#define show
// #define cerr 
#endif

#define declare ull mid=(left+right)/2,v_left=v*2,v_right=v*2+1
class seg_tree{
    ull start,end,pos,x;
    vector<ll>arr;
    vector<pi>tree;
    void clear(ull v){
        tree[v]={INF, -INF};
    }
    void accum(ull v_left,ull v_right){
        // if(tree[v_left].sd < tree[v_left].ft)
        //     swap(tree[v_left].sd, tree[v_left].ft);
        // if(tree[v_right].sd < tree[v_right].ft)
        //     swap(tree[v_right].sd, tree[v_right].ft);
        tree[v_left].ft = min(tree[v_right].ft, tree[v_left].ft);
        tree[v_left].sd = max(tree[v_right].sd, tree[v_left].sd);
    }
    void update(ull v,ull v_left,ull v_right){
        clear(v);
        accum(v,v_left);
        accum(v,v_right);
    }
    void build(ull v, ull left, ull right){
        if(left+1==right) {
            tree[v] = {arr[left], arr[left]};
        }
        else{
            declare;
            build(v_left,left,mid);
            build(v_right,mid,right);
            update(v,v_left,v_right);
        }
    }
    void get_tr(ull v, ull left, ull right){
        if(start<=left && right<=end)
            accum(0,v);
        else{
            declare;
            if(start<mid)
                get_tr(v_left,left,mid);
            if(mid<end)
                get_tr(v_right,mid,right);
        }
    }
    void change_tr(ull v, ull left, ull right){
        if(left+1==right)
            tree[v] = {x, x};
        else{
            declare;
            if(pos<mid)
                change_tr(v_left,left,mid);
            else
                change_tr(v_right,mid,right);
            update(v,v_left,v_right);
        }
    }
 
public:
    seg_tree(const vector<ll>&v):tree(isz(v)<<2,{-INF, INF}),arr(v){
        build(1,0,isz(v));
    }
    void change(ull _pos,ull _x){
        pos=_pos;
        x=_x;
        change_tr(1,0,isz(arr));
    }
    pi get(ull _start, ull _end){
        clear(0);
        start=_start;
        end=_end+1;
        get_tr(1,0,isz(arr));
        return tree[0];
    }
};
long long mergeAndCount(vector<int>& arr, int left, int mid, int right) {
    vector<int> temp(right - left + 1);
    long long inversionCount = 0;
    int i = left;    // Index for left subarray
    int j = mid + 1;  // Index for right subarray
    int k = 0;        // Index for temporary array
    while (i <= mid && j <= right) {
      if (arr[i] <= arr[j]) {
          temp[k++] = arr[i++];
        } else {
            // If element from the right subarray is smaller, it forms inversions with the elements in the left subarray
            inversionCount += mid - i + 1;
            temp[k++] = arr[j++];
        }
    }
    // Copy the remaining elements of left subarray, if any
    while (i <= mid) {
      temp[k++] = arr[i++];
    }
    // Copy the remaining elements of right subarray, if any
    while (j <= right) {
      temp[k++] = arr[j++];
    }
    // Copy the merged elements back to the original array
    for (int p = 0; p < k; ++p) {
      arr[left + p] = temp[p];
    }
    return inversionCount;
}
// Recursive function to perform merge sort and count inversions
long long mergeSortAndCount(vector<int>& arr, int left, int right) {
    long long inversionCount = 0;
    if (left < right) {
      int mid = left + (right - left) / 2;
        // Count inversions in the left subarray
        inversionCount += mergeSortAndCount(arr, left, mid);
        // Count inversions in the right subarray
        inversionCount += mergeSortAndCount(arr, mid + 1, right);
        // Merge the sorted halves and count inversions
        inversionCount += mergeAndCount(arr, left, mid, right);
    }
    return inversionCount;
}

void solution(int _t){
    string s;
    cin >> s;
    vector<char> v;
    int ct = 0;
    int ma = 0;
    forx(i, 1 , isz(s) - 1){
        if (s[i] == '{') {
            // v.push_back(i);
             ct += 1;
        }
        else if (s[i] == '}') {
            ct -= 1;
            if (ct == 0)
             ma += 1;
        }
        else {
        }
    }
    cout << ma << "\n";
}

int32_t main() {
    // SetConsoleCP(65001);
    // SetConsoleOutputCP(65001);
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout.setf(ios::fixed);
    cout.precision(20);
    //    freopen("allgood.in", "r", stdin);
    //    freopen("allgood.out", "w", stdout);

    int t = 1;
    // cin >> t;

    while (t--) {
        solution(t);
        // cout << "\n";
    }
}