// #pragma GCC optimize("O3,unroll-loops")
   
// #include <iostream>
// #include <vector>
// #include <algorithm>
 
// using namespace std;
  
// int main() {
//     #define int long long
//     ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);
//     int n;
//     cin >> n;
//     int** matr = new int*[n];
//     for(int i = 0; i < n; i++){
//         matr[i] = new int[n];
//     }
//     for (int i = 0; i < n; i++) {
//         for (int j = 0; j < n; j++) {
//             cin >> matr[i][j];
//         }
//     }
//     int** d = new int*[n];
//     for(int i = 0; i < n; i++){
//         d[i] = new int[n];
//     }
//     copy(matr, matr + n, d);
//     for (int k=0; k<n; ++k) {
//         for (int i=0; i<n; ++i) {
//             for (int j=0; j<n; ++j) {
//                 if(i == j) continue;
//                 d[i][j] = min (d[i][j], d[i][k] + d[k][j]);
//                 d[j][i] = min (d[j][i], d[j][k] + d[k][i]);
//             }
//         }
//     }
 
//     for (int i = 0; i < n; i++) {
//         for (int j = 0; j < n; j++) {
//             if (d[i][j] < matr[i][j]) {
//                 //cout << d[i][j] << " " << matr[i][j] << "\n";
//                 cout << "No";
//                 return 0;
//             }
//         }
//     }
     
//     cout << "Yes";
// }

#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
#include <tuple>
#include <cstdint>

using namespace std;

const int INF = INT32_MAX;

struct Edge {
    int f = -1, s = -1, len = -1;
    Edge() = default;
};

bool operator<(Edge a, Edge b) {
    return a.len < b.len;
}

int shortest_path(int s, int f, vector<vector<pair<int, int>>> &g) {
    vector<int> dist(g.size(), INF);
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> pq;

    dist[s] = 0;
    pq.push({0, s});

    while (!pq.empty()) {
        auto [d, v] = pq.top();
        pq.pop();

        if (v == f) return d;

        for (auto [u, w] : g[v]) {
            if (dist[u] > d + w) {
                dist[u] = d + w;
                pq.push({dist[u], u});
            }
        }
    }
    return INF;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    
    int n;
    cin >> n;
    vector<vector<int>> matr(n, vector<int>(n));
    vector<vector<pair<int, int>>> graph(n);
    vector<Edge> edges;

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            cin >> matr[i][j];
            if (j > i) edges.push_back({i, j, matr[i][j]});
        }
    }
    
    sort(edges.begin(), edges.end());

    for (const auto& edge : edges) {
        int dist = shortest_path(edge.f, edge.s, graph);
        
        if (dist < edge.len) {
            cout << "No";
            return 0;
        } else if (dist == INF || dist > edge.len) {
            graph[edge.f].emplace_back(edge.s, edge.len);
            graph[edge.s].emplace_back(edge.f, edge.len);
        }
    }

    cout << "Yes";
    return 0;
}
