#include <bits/stdc++.h>
// #pragma comment(linker, "/STACK:16777216")
// #pragma GCC optimize("O3,unroll-loops")
// #pragma GCC target("avx2,sse4,fma,bmi,bmi2,popcnt,lzcnt,abm,tune=native")

using namespace std;
using uint = unsigned int;
using ll = long long;
using ull = unsigned long long;
using dbl = double;
using ld = long double;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pd = pair<dbl, dbl>;
using pld = pair<ld, ld>;

// #include <ext/pb_ds/assoc_container.hpp>
// #include <ext/pb_ds/tree_policy.hpp>
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ft first
#define sc second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct segtree {
    int sz = 1;
    vector<int> tree;

    segtree(int n) {
        while (sz < n) sz *= 2;
        tree.resize(2 * sz);
    }

    void add(int x, int i) {
        i += sz;
        tree[i] += x;
        i /= 2;
        while (i > 0) {
            tree[i] = tree[2 * i] + tree[2 * i + 1];
            i /= 2;
        }
    }

    int get(int l, int r, int lx, int rx, int node) {
        if (l >= rx || r <= lx) return 0;
        if (l <= lx && rx <= r) return tree[node];
        int mid = (lx + rx) / 2;
        int get1 = get(l, r, lx, mid, node * 2);
        int get2 = get(l, r, mid, rx, node * 2 + 1);
        return get1 + get2;
    }
};

void solve() {
    string s;
    int k;
    cin >> s >> k;
    vector<set<int>> id(10);
    for (int i = 0; i < s.size(); i++) {
        id[s[i] - '0'].insert(i);
    }
    segtree st(s.size());
    int ptr = 0;
    string ans;
    vector<bool> used(s.size(), false);

    for (int i = 0; i < s.size(); i++) {
        if (used[i]) continue;
        int digit = s[i] - '0';
        for (int d = 1; d < digit; d++) {
            vector<int> to_remove;
            for (auto j: id[d]) {
                int distance = j - i;
                distance -= st.get(i + 1, j, 0, st.sz, 1);
                if (distance <= k) {
                    k -= distance;
                    ans.pb((char) ('0' + d));
                    used[j] = true;
                    st.add(1, j);
                    to_remove.pb(j);
                } else {
                    break;
                }
            }
            for (auto x: to_remove) id[d].erase(x);
        }
        ans.pb(s[i]);
        id[s[i] - '0'].erase(i);
        used[i] = true;
    }
    for (int i = 0; i < s.size(); i++)
        if (!used[i])
            ans.pb(s[i]);
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}
