#include <bits/stdc++.h>

using namespace std;

template<class T>
ostream& operator<<(ostream& out, const vector<T>& a) {
  for (auto& i : a) {
    out << i << " ";
  }
  return out;
}

template<class T>
T read() {
  T t;
  cin >> t;
  return t;
}

template<class T>
void operator>>(istream& in, vector<T>& a) {
  for (auto& i : a) {
    in >> i;
  }
}

template<class T>
void operator>>(istream& in, vector<vector<T>>& a) {
  for (auto& i : a) {
    in >> i;
  }
}

#define ll long long
#define ull unsigned ll
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define X first
#define Y second
constexpr ll MOD = 1e9 + 9;


bool check_symmetry_and_diagonal(const vector<vector<int>>& matrix, int n) {
  for (int i = 0; i < n; ++i) {
    if (matrix[i][i] != 0) return false;
    for (int j = i + 1; j < n; ++j) {
      if (matrix[i][j] != matrix[j][i]) return false;
    }
  }
  return true;
}

bool check_triangle_inequality(const vector<vector<int>>& matrix, int n) {
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < n; ++j) {
      for (int k = 0; k < n; ++k) {
        if (matrix[i][j] > matrix[i][k] + matrix[k][j]) {
          return false;
        }
      }
    }
  }
  return true;
}

bool is_connected(const vector<vector<int>>& matrix, int n) {
  vector<bool> visited(n, false);
  queue<int> q;
  q.push(0);
  visited[0] = true;
  int visited_count = 1;

  while (!q.empty()) {
    int u = q.front();
    q.pop();

    for (int v = 0; v < n; ++v) {
      if (u != v && matrix[u][v] > 0 && !visited[v]) {
        visited[v] = true;
        q.push(v);
        visited_count++;
      }
    }
  }
  return visited_count == n;
}

void solution() {
  int n = read<int>();
  vector<vector<int>> a(n, vector<int>(n));
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++) {
      a[i][j] = read<ll>();
    }
  }

  if (check_symmetry_and_diagonal(a, n) &&
        check_triangle_inequality(a, n) &&
        is_connected(a, n)) {
    cout << "Yes";
  } else {
    cout << "No";
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
  auto ttt = 1;
  while (ttt--) {
    solution();
  }
}
