#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back

#ifndef LOCAL
    #define cerr if (0) cerr
#endif

using namespace std;

template<typename T, typename V> ostream& operator<<(ostream& out, pair<T, V> p)
{
   out << p.fi << ", " << p.se;

   return out;
}

template<typename T> ostream& operator<<(ostream& out, vector<T> v)
{
    out << "[";
    for(auto e : v) out << e << ", ";
    out << "]";

    return out;
}

using ll = long long;
using ld = long double;
using vi = vector<int>;
using vvi = vector<vi>;
using pii = pair<int,int>;

void solve();

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1;
    cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}

#define int ll

struct SegT{
    vi tree;
    vi p;
    int sz;

    void init(int n){
        sz = 1;
        while(sz < n) sz <<= 1;
        tree.assign(2*sz - 1, 0);
        p.assign(2*sz - 1, 0);
    }

    void push(int i, int l)
    {
        tree[2*i + 1] += p[i] * l / 2;
        tree[2*i + 2] += p[i] * l / 2;
    
        p[2*i + 1] += p[i];
        p[2*i + 2] += p[i];
    
        p[i] = 0;
    }

    int get(int i, int x, int lx, int rx){
        if(rx - lx == 1) return tree[x];

        push(x, rx - lx);

        int m = (lx + rx) / 2;
        if(i < m) return get(i, 2*x+1, lx, m);
        else return get(i, 2*x+2, m, rx);
    }

    int get(int i){
        return get(i, 0, 0, sz);
    }

    void add(int l, int r, int v, int x, int lx, int rx){
        if(r <= lx || rx <= l) return;
        if(l <= lx && rx <= r) {
            tree[x] += v * (rx - lx);
            p[x] += v;
            return;
        }
        push(x, rx - lx);

        int m = (lx + rx) / 2;
        add(l, r, v, 2*x+1, lx, m);
        add(l, r, v, 2*x+2, m, rx);

        tree[x] = tree[2*x+1] +  tree[2*x+2];
    }

    void add(int l, int r){
        add(l, r, 1, 0, 0, sz);
    }
};

void solve()
{
    string s; cin >> s;
    ll k; cin >> k;

    int n = int(s.size());
    vi a(n);
    for(int i = 0; i < n; i++){
        a[i] = (s[i] - '0');
    }

    SegT delta;
    delta.init(n);

#define sz(x) int(x.size())

    vvi cnt(10);
    vi ptr(10, 0);
    for(int i = 0; i < n; ++i)
        cnt[a[i]].pb(i);

    vi ans(n);

    for(int i = 0; i < n; ){
        if(a[i] == 0){
            i++;
            continue;
        }
        int ind = i + delta.get(i);
        int fl = 0;

        for(int j = 1; j < a[i]; j++){
            if(ptr[j] >= sz(cnt[j])) continue;

            int ind1 = cnt[j][ptr[j]] + delta.get(cnt[j][ptr[j]]);
            while(ind1 <= ind){
                ptr[j]++;
                if(ptr[j] >= sz(cnt[j])) break; 
                ind1 = cnt[j][ptr[j]] + delta.get(cnt[j][ptr[j]]);
            }
            if(ptr[j] >= sz(cnt[j])) continue;

            if(ind1 - ind <= k){
                fl = 1;
                ans[ind] = j;
                a[cnt[j][ptr[j]]] = 0;
                delta.add(0, cnt[j][ptr[j]]+1);
                ptr[j]++;
                k -= ind1 - ind;
                break;
            }
        }
        if(!fl) {
            ans[ind] = a[i];
            i++;
        }
    }

    for(int i = 0; i < n; i++){
        cout << ans[i];
    }
    cout << '\n';
}