#include <iostream>
#include <algorithm>
#define MOD 998244353

using namespace std;

long long fact(long long n) {
    long long result = 1;
    for (long long i = 2; i <= n; i++) {
        result = (result * i) % MOD;
    }
    return result;
}

long long modIn(long long x, long long mod) {
    long long result = 1, power = mod - 2;
    while (power) {
        if (power % 2 == 1) result = (result * x) % mod;
        x = (x * x) % mod;
        power /= 2;
    }
    return result;
}

long long combo(long long n, long long k) {
    if (k > n) return 0;
    long long num = fact(n);
    long long denom = (fact(k) * fact(n - k)) % MOD;
    return (num * modIn(denom, MOD)) % MOD;
}

int main() {
    long long r, g, b;
    cin >> r >> g >> b;
    if (abs(r - g) > 1 || abs(g - b) > 1 || abs(r - b) > 1) {
        cout << 0 << endl;
        return 0;
    }

    long long result = 0;
    if (r == g && g == b) {
        result = 6;
    }
    else if (r == g + 1 && g == b) {
        result = 2;
    }
    else if (r == g && g == b + 1) {
        result = 2;
    }
    else {
        result = (combo(r + g, r) * combo(g + b, g) % MOD) % MOD;
    }

    cout << result << endl;

    return 0;
}
