from collections import defaultdict, deque

n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]

graph = defaultdict(set)
ribs = []
for i in range(n):
    for j in range(i, n):
        if i == j:
            continue
        ribs.append((matrix[i][j], i, j))

ribs.sort()


def BFS(frm, dst):
    deq = deque()
    for j in graph[frm]:
        deq.append((j, matrix[frm][j]))
    walked = {frm}
    while len(deq) > 0:
        i = deq.popleft()
        if i[0] == dst:
            return i[1]
        for j in graph[i[0]]:
            if j not in walked:
                deq.append((j, matrix[i[0]][j] + i[1]))
                walked.add(j)
    return -1

flag = True

for rib in ribs:
    ln = BFS(rib[1], rib[2])
    if ln == -1:
        graph[rib[1]].add(rib[2])
        graph[rib[2]].add(rib[1])
    elif ln != rib[0]:
        flag = False
        break

if flag:
    print("Yes")
else:
    print("No")