#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <stack>
#include <map>

using namespace std;

typedef long long ll;



struct SeqTree { //min
    int inf = 11;
    vector<int> cnt;
    vector<pair<int, int>> t;
    int sz = 1;
    
    void built(int v, int l, int r, vector<int>& vec)
    {
        if (r - l == 1)
        {
            if (l < vec.size())
            {
                t[v] = { vec[l], l };
                cnt[v] = 1;
            }
            return;
        }
        int mid = (l + r) / 2;
        built(2 * v + 1, l, mid, vec);
        built(2 * v + 2, mid, r, vec);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
        cnt[v] = cnt[2 * v + 1] + cnt[2 * v + 2];
    }

    void Init(vector<int> &v) {
        while (sz <= v.size())
        {
            sz *= 2;
        }
        cnt.assign(sz * 2, 0);
        t.assign(sz * 2, { inf, inf });
        built(0, 0, sz, v);
    }

    void remove(int v, int l, int r, int ind)
    {
        if (ind >= r || ind < l)
            return;
        if (r - l == 1)
        {
            t[v] = { inf, inf };
            cnt[v] = 0;
            return;
        }
        int mid = (l + r) / 2;
        remove(2 * v + 1, l, mid, ind);
        remove(2 * v + 2, mid, r, ind);

        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
        cnt[v] = cnt[2 * v + 1] + cnt[2 * v + 2];
    }

    pair<int, int> get(int v, int l, int r, ll k) //num, ind, cnt
    {
        if (k <= 0)
        {
            return {inf, inf};
        }
        if (r - l == 1)
        {
            return t[v];
        }
        if (cnt[v] <= k)
        {
            return t[v];
        }
        int mid = (l + r) / 2;
        auto resl = get(v*2+1, l, mid, min((ll)cnt[2 * v + 1], k));
        auto resr = get(v*2+2, mid, r, k - min((ll)cnt[2 * v + 1], k));
        return min(resl, resr);
    }

    int getleft(int v, int l, int r, int ind)
    {
        if (ind <= l)
            return 0;
        if (r <= ind)
            return cnt[v];
        int mid = (l + r) / 2;
        return getleft(2 * v + 1, l, mid, ind) + getleft(2 * v + 2, mid, r, ind);
    }
};

int main()
{
    ios_base::sync_with_stdio(0);
    int t;
    cin >> t;
    while (t--)
    {
        string s, ans;
        vector<int> v;
        ll k = 0;
        cin >> s >> k;
        for (int i = 0; i < s.size(); i++)
            v.push_back(s[i] - '0');

        SeqTree tree;
        tree.Init(v);
        while (k > 0 && tree.cnt[0] > 0)
        {
            auto res = tree.get(0, 0, tree.sz, k + 1);
            int left = tree.getleft(0, 0, tree.sz, res.second);
            k -= left;
            ans.push_back('0' + res.first);
            tree.remove(0, 0, tree.sz, res.second);
        }

        while (tree.cnt[0] > 0)
        {
            auto res = tree.get(0, 0, tree.sz, 1);
            ans.push_back('0' + res.first);
            tree.remove(0, 0, tree.sz, res.second);
        }
        cout << ans << endl;
    }
}