#include <iostream>
#include <random>
#include <vector>
#include <ctime>
#define ll long long

using namespace std;

constexpr ll MOD = 998'244'353;

std::mt19937_64 rnd(time(0));
constexpr ll N = 200005;

ll fact[N], infact[N];

ll binpow(ll h, ll r) {
  ll l = 1;
  while (r) {
    if (r & 1) {
      l = l * h % MOD;
    }
    h = h * h % MOD;
    r /= 2;
  }
  return l;
}

ll C(ll n, ll k) {
  return fact[n] * infact[k] % MOD * infact[n - k] % MOD;
}

void solve() {
  ll a, b, c;
  cin >> a >> b >> c;
  c++;
  if (abs(a - b) > c) {
    cout << 0 << endl;
    return;
  }
  ll ans = 0;
  ll fr1 = abs(a - b), fr2 = 0;
  ll o = min(a, b);
  for (int i = fr1; fr1 + fr2 <= c; fr1++, fr2++, o--) {
    ll m1, m2, m3;
    if (c >= fr1 + fr2 && o >= (c - fr1 - fr2) && c >= 0) {
      m1 = C(c, fr1 + fr2) * C(fr1 + fr2, fr1) % MOD * binpow(c, o - (c - fr1 - fr2)) % MOD * binpow(2, c - fr1 - fr2) % MOD;
      ans = (ans + m1) % MOD;
    }
    if (c - 1 >= fr1 + fr2 && o >= (c - 1 - fr1 - fr2) && c >= 1)
    {
      m2 = C(c - 1, fr1 + fr2) * C(fr1 + fr2, fr1) % MOD * binpow(c - 1, o - (c - 1 - fr1 - fr2)) % MOD * binpow(2, c - 1 - fr1 - fr2) % MOD;
      ans = (ans + m2 * 2 % MOD) % MOD;
    }
    if (c - 2 >= fr1 + fr2 && o >= (c - 2 - fr1 - fr2) && c >= 2)
    {
      m3 = C(c - 2, fr1 + fr2) * C(fr1 + fr2, fr1) % MOD * binpow(c - 2, o - (c - 2 - fr1 - fr2)) % MOD * binpow(2, c - 2 - fr1 - fr2) % MOD;
      ans = (ans + m3 % MOD) % MOD;
    }
  }
  cout << ans << endl;
}

int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);
  fact[0] = 1;
  infact[0] = 1;
  for (ll i = 1 ; i <= N; i++) {
    fact[i] = fact[i - 1] * i % MOD;
    infact[i] = binpow(fact[i], MOD - 2);
  }
  ll t = 1;
  while (t--) {
    solve();
  }
}

/*
6 1 3
1 5 8
5 3 2
6 5 9
2 1 4
2 4 6
1 2
12 3
15 6
4 3
10 2
*/