#include <bits/stdc++.h>

using namespace std;

#define int long long

const int INF64 = 1e18;

struct TSegmentTree {
    vector<int> t;
    int sz;

    TSegmentTree(int n) {
        sz = 1;
        while (sz < n) {
            sz <<= 1;
        }

        t.resize(sz << 1, 0);
    }

    void push(int v) {
        if (v < sz) {
            int delta = (t[v] - t[v << 1] - t[v << 1 | 1]);
            t[v << 1] += delta;
            t[v << 1 | 1] += delta;
        }
    }

    int get(int v, int l, int r, int ql, int qr) {
        push(v);
        if (qr <= l || r <= ql) {
            return 0;
        }

        if (ql <= l && r <= qr) {
            return t[v];
        }

        int mid = (l + r) >> 1;

        return get(v << 1, l, mid, ql, qr) + get(v << 1 | 1, mid, r, ql, qr);
    }

    void upd(int v, int l, int r, int ql, int qr, int x) {
        push(v);

        if (qr <= l || r <= ql) {
            return;
        }

        if (ql <= l && r <= qr) {
            t[v] += x;
            push(v);
            return;
        }

        int mid = (l + r) >> 1;

        upd(v << 1, l, mid, ql, qr, x);
        upd(v << 1 | 1, mid, r, ql, qr, x);

        t[v] = t[v << 1] + t[v << 1 | 1];
    }

    int get(int l, int r) {
        return get(1, 0, sz, l, r + 1);
    }

    void upd(int l, int r, int x) {
        upd(1, 0, sz, l, r + 1, x);
    }
};

void solve(int cntTest) {
    string s;
    cin >> s;
    int k; cin >> k;

    string result = "";

    int n = s.size();
    vector<deque<int>> mp(10);

    for (int i = 0; i < n; i++) {
        mp[s[i] - '0'].push_back(i);
    }

    TSegmentTree t(n);

    while (result.size() < s.size()) {
        pair<int, int> kek = {100, 0};

        for (int x = 1; x < 10; x++) {
            if (mp[x].size() == 0) {
                continue;
            }

            int i = mp[x].front();
            i += t.get(i, i);

            int l = result.size();
            int r = min<int>(s.size() - 1, l + k);

            if (i <= r) {
                kek = min(kek, {x, i});
            }
        }

        k -= kek.second - result.size();
        result.push_back(kek.first + '0');
        t.upd(0, kek.second, 1);
        mp[kek.first].pop_front();
    }

    cout << result << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed << setprecision(10);

    // freopen("input.txt", "r", stdin);

    int cntTest = 1;
    cin >> cntTest;

    for (int i = 1; i <= cntTest; i++) {
        solve(i);
    }
}
