// #pragma GCC optimize("Ofast,no-stack-protector,unroll-loops,fast-math")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2,popcnt")
// #pragma GCC target("avx,avx2")

#pragma GCC optimize("Ofast,unroll-loops")

// #define FAST_ALLOCATOR_MEMORY 2.5e8

// #include "optimization.h"
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef unsigned int uint;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

#define forn(i, n) for (ll i = 0; i < (ll)(n); i++)

std::random_device dev;
std::mt19937 rng(dev());
ll mod = 1e9 + 7;
std::uniform_int_distribution<std::int64_t> uid(1, 20);

struct custom_hash {
  static uint64_t splitmix64(uint64_t x) {
    x += 0x9e3779b97f4a7c15;
    x = (x ^ (x >> 30)) * 0xbf58476d1ce4e5b9;
    x = (x ^ (x >> 27)) * 0x94d049bb133111eb;
    return x ^ (x >> 31);
  }

  size_t operator()(uint64_t x) const {
    static const uint64_t FIXED_RANDOM =
        std::chrono::steady_clock::now().time_since_epoch().count();
    return splitmix64(x + FIXED_RANDOM);
  }
};

struct pair_hash {
  template <class T1, class T2>
  std::size_t operator()(const std::pair<T1, T2> &p) const {
    auto h1 = std::hash<T1>{}(p.first);
    auto h2 = std::hash<T2>{}(p.second);
    return h1 ^ h2;
  }
};

void solve() {
  int n, m;
  cin >> n >> m;

  bool ans = true;
  forn(i, n) {
    unordered_map<char, int> cnt;
    forn(j, m) {
      char x;
      cin >> x;
      if (x == '-') {
        continue;
      }
      cnt[x]++;
    }

    if (cnt['A'] != 1 || cnt['C'] == 0 || cnt['I'] == 0) {
      ans = false;
    }
  }

  cout << (ans ? "YES" : "NO") << "\n";
}

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);

  int t = 1;
  // cin >> t;
  // t = readInt();

  while (t--) {
    solve();
  }
  return 0;
}