#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <string>
#include <map>

#define ll long long
#define ld long double

using namespace std;

map <ll, string> gov = {
    {0, "1110111"},
    {1, "0010010"},
    {2, "1011101"},
    {3, "1011011"},
    {4, "0111010"},
    {5, "1101011"},
    {6, "1101111"},
    {7, "1010010"},
    {8, "1111111"},
    {9, "1111011"},
};

map <string, ll> no = {
    {"1110111", 0},
    {"0010010", 1},
    {"1011101", 2},
    {"1011011", 3},
    {"0111010", 4},
    {"1101011", 5},
    {"1101111", 6},
    {"1010010", 7},
    {"1111111", 8},
    {"1111011", 9},
};

string f, s;

string step(ll a, string mask) {
    string res = gov[a];

    for (ll i = 0; i < 7; i++) {
        if (mask[i] == '0')
            res[i] = '0';
    }

    return res;
}

pair <ll, bool> dt(ll a) {
    string p1 = "1110111";
    if (a > 9) {
        p1 = step(a / 10, f);
    }
    string p2 = step(a % 10, s);

    ll res = 0;
    if (no.count(p1) != 0) {
        res = no[p1] * 10;
    } else {
        return {-100, false};
    }

    if (no.count(p2) != 0) {
        res += no[p2];
    } else {
        return {-100, false};
    }
    
    return {res, true};
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> f >> s;

    ll ans = 0, temp = 0;

    ll i = 99, prev;
    for (i = 99; i >= 0; i--) {
        auto res = dt(i);
        if (res.second) {
            prev = res.first;
            break;
        }
    }
    for (; i >= 0; i--) {
        auto res = dt(i);
        if (!res.second || res.first - prev != 1) {
            ans = max(ans, temp);
            temp = 0;
        } else {
            temp++;
        }

        prev = res.first;
    }
    
    cout << max(ans, temp);
    return 0;
}
