﻿#include "bits/stdc++.h"

using namespace std;
#define int long long

std::mt19937 azino(777);

struct Node{
    int x,y, val, size, mi;
    Node* l, *r;
    Node(int val_) : x(val_), val(val_), y(azino()), size(1), l(nullptr), r(nullptr), mi(val_) {};
};

int getsize(Node*v){
    if (v == nullptr) return 0;
    return v->size;
}

int getmi(Node* v){
    if (v == nullptr) return 1e9;
    return v->mi;
}

int getval(Node* v){
    if (v == nullptr) return 1e9;
    return v->val;
}

void update(Node* v){
    if (v == nullptr) return;
    v->size = 1 + getsize(v->l) + getsize(v->r);
    v->mi = std::min(v->val, std::min(getmi(v->l), getmi(v->r)));
}

Node* merge(Node* a, Node* b) {
    if (a == nullptr) return b;
    if (b == nullptr) return a;
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        update(a);
        return a;
    } else {
        b->l = merge(a, b->l);
        update(b);
        return b;
    }
}

std::pair<Node*, Node*> split(Node* v, int k) {
    if (v == nullptr) return {nullptr, nullptr};
    int L = getsize(v->l);
    if (L >= k) {
        auto a = split(v->l, k);
        v->l = a.second;
        update(v);
        return {a.first, v};
    } else {
        auto a = split(v->r, k - L - 1);
        v->r = a.first;
        update(v);
        return {v, a.second};
    }
}

int getpos(Node* root, int val) {
    int pos = 0;
    Node* cur = root;
    while (cur != nullptr) {
        if (getmi(cur->l) <= val) {
            cur = cur->l;
            continue;
        } else {
            pos += getsize(cur->l);
        }
        if (getval(cur) == val) return pos;
        cur = cur->r;
        pos++;
    }
    return pos;
}

Node* remove(Node* root, int pos) {
    auto a = split(root, pos);
    auto b = split(a.second, 1);
    return merge(a.first, b.second);
}

std::tuple<Node*, int, int> getmin(Node* root, int r) {
    auto a = split(root, r + 1);
    int mi = a.first->mi;
    int pos = getpos(a.first, mi);
    a.first = remove(a.first, pos);
    root = merge(a.first, a.second);
    return {root, mi, pos};
}

void solve()
{
    std::string s;
    std::vector<int> ans;
    int k;
    std::cin >> s >> k;
    int n = s.size();
    Node* root = nullptr;
    for (int i = 0; i < n; ++i) {
        root = merge(root, new Node(s[i] - '0'));
    }
    for (int i = 0; i < n; ++i) {
        int R = std::min(k, n - i - 1);
        auto kek = getmin(root, R);
        k -= get<2>(kek);
        ans.push_back(get<1>(kek));
        root = get<0>(kek);
    }
    for (auto&x : ans) cout << x;
    std::cout << '\n';
}

signed main()
{
    int _ = 1;  cin >> _;
    while (_--)
    {
        solve();
    }
}
