﻿#include "bits/stdc++.h"

using namespace std;
#define int long long

struct pr {
    int w, x, y;

    bool operator<(pr t) const {
        return w < t.w;
    }
};
const int maxn = 1001;
int p[maxn], s[maxn];

int leader(int v) {
    return (p[v] == v) ? v : p[v] = leader(p[v]);
}

void unite(int a, int b) {
    a = leader(a), b = leader(b);
    if (s[a] > s[b])
        swap(a, b);
    s[b] += s[a];
    p[a] = b;
}

void init(int n) {
    for (int i = 0; i < n; i++)
        p[i] = i, s[i] = 1;
}

vector<vector<pair<int,int>>> g;
vector<int> dijkstra(int from, int n) {
    vector<int> d(n, 1e18);
    d[from] = 0;
    set<pair<int, int>> q;
    q.insert({0, from});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto [u, w] : g[v]) {
            if (d[u] > d[v] + w) {
                q.erase({d[u], u});
                d[u] = d[v] + w;
                q.insert({d[u], u});
            }
        }
    }
    return d;
}


void solve() {
    int n; cin >> n;
    vector<vector<int>> t(n, vector<int>(n));
    vector<pr> b;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cin >> t[i][j];
            if (i < j) {
                b.push_back({t[i][j], i, j});
            }
        }
    }
    sort(b.begin(), b.end());
    init(n);
    g.resize(n);
    for (auto e : b) {
        if (leader(e.x) == leader(e.y)) {
            continue;
        }
        g[e.x].emplace_back(e.y, e.w);
        g[e.y].emplace_back(e.x, e.w);
        unite(e.x, e.y);
    }
    bool kek = false;
    for (int i = 0; i < n; ++i) {
        if (s[i] == n) {
            kek = true;
        }
    }
    if (!kek) {
        cout << "No"; return;
    }
    // теперь это точно связное дерево
    vector<vector<int>> real(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        real[i] = dijkstra(i, n);
    }
    bool ans = true;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (t[i][j] != real[i][j]) {
                ans = false;
            }
        }
    }
    cout << (ans ? "Yes" : "No");
}

signed main() {
    int _ = 1; //cin >> _;
    while (_--) {
        solve();
    }
}
