#include <algorithm>
#pragma GCC optimize("O3,Ofast")
#include <bits/stdc++.h>

using namespace std;

template<typename A, typename B> ostream& operator<<(ostream &os, const pair<A, B> &p) { return os << '(' << p.first << ", " << p.second << ')'; }
template<typename T_container, typename T = typename enable_if<!is_same<T_container, string>::value, typename T_container::value_type>::type> ostream& operator<<(ostream &os, const T_container &v) { os << '{'; string sep; for (const T &x : v) os << sep << x, sep = ", "; return os << '}'; }
void dbg_out() { cerr << endl; }
template<typename Head, typename... Tail> void dbg_out(Head H, Tail... T) { cerr << ' ' << H; dbg_out(T...); }
#ifdef LOCAL
#define dbg(...) cerr << "(" << #__VA_ARGS__ << "):", dbg_out(__VA_ARGS__)
#else
#define dbg(...)
#endif

#define ll long long
#define ld long double
#define all(a) (a).begin(), (a).end()

const int MAX_N = 1e5 + 5;
const ll MOD = 1e9 + 7;
const ll INF = 1e9;
const ld EPS = 1e-9;

template<class T>
struct rsq_add_segt {
	explicit rsq_add_segt(size_t sz = 0, const T &val = 0) {
		for(d=1; d<sz; d<<=1);
		t.assign(d*2, {val, {}});
	}

	rsq_add_segt(const vector<T> &vals): rsq_add_segt(size(vals)) {
		for(size_t i=0; i<size(vals); ++i) t[i+d].first = vals[i];
		for(size_t i=d; i-->1; ) t[i].first = t[i*2].first + t[i*2+1].first;
	}

	void add(size_t l, size_t r, const T &val) {
		if(l>=r) return ;
		_add(l, r, val, 0, d, 1);
	}

	T operator()(size_t l, size_t r) const {
		if(l>=r) return {};
		return _calc(l, r, 0, d, 1);
	}

	private:
	size_t d;
	//t[i] = pair of #(sum on range of node) and #(total additions on range of node)
	vector<pair<T,T>> t;

	void _add(size_t i, size_t j, const T &val, size_t l, size_t r, size_t v) {
		//adding to whole range
		if(i==l && j==r){
			//sum increases by value * length_of_range
			t[v].first+=val*T(r-l);
			//total addition increases by value
			t[v].second+=val;
			return ;
		}
		size_t m = (l+r)>>1;
		if(i<m) _add(i,min(j,m),val,l,m,v*2);
		if(m<j) _add(max(i,m),j,val,m,r,v*2+1);
		//update current node: sum on range is sum of children + own addition
		t[v].first = t[v*2].first + t[v*2+1].first + t[v].second * T(r-l);
	}

	T _calc(size_t i, size_t j, size_t l, size_t r, size_t v) const {
		//sum of whole range already known
		if(i==l && j==r) return t[v].first;
		size_t m = (l+r)>>1;
		return
		//query splited to children
		(j<=m ? _calc(i,j,l,m,v*2) : i>=m ? _calc(i,j,m,r,v*2+1)
		 : _calc(i,m,l,m,v*2) + _calc(m,j,m,r,v*2+1))
		//and adding own addition
		  + t[v].second * T(j-i);
	}
};

void solve() {
    string s;
    cin >> s;
    ll k;
    cin >> k;

    vector<unsigned int> a(s.size());

    for (ll i = 0;i < s.size(); ++i) {
        a[i] = s[i] - '0';
    }

    vector<deque<ll>> nums(10, deque<ll>());

    for (ll i = 0; i < s.size(); ++i) {
        nums[a[i]].push_back(i);
    }

    vector<ll> b;
    rsq_add_segt<ll> offset(s.size());
    for (ll i = 0; i < s.size(); ++i) {
        for (ll j = 1; j < 10; ++j) {
            auto& deq = nums[j];

            bool done = false;
            for (ll l = 0; l < deq.size(); ++l) {
                ll ofs = offset(deq[l], deq[l]+1);
                if (deq[l] - i + ofs > k) {
                    break;
                }

                k -= deq[l] - i;
                offset.add(i, deq[l] + ofs, 1);
                deq.pop_front();
                b.push_back(j);
                done = true;
                break;
            }

            if (done){
                break;
            }
        }
        if (k == 0) {
            break;
        }

   }


   b.resize(s.size());
   for (int i = 0; i < nums.size(); ++i) {
       auto& deq = nums[i];
       for (int j = 0; j < deq.size(); ++j) {
           ll ofs = offset(deq[j], deq[j]+1);
           b[deq[j] + ofs] = i;
       }
   }




   for (int i = 0; i < b.size(); ++i) {
       cout << b[i];
   }

   cout << '\n';



}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int tc = 1;
    cin >> tc;
    for (int t = 1; t <= tc; t++) {
        // cout << "Case #" << t << ": ";
        solve();
    }
}
