#include <algorithm>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <compare>
#include <complex>
#include <cstddef>
#include <cstdlib>
#include <cstring>
#include <deque>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>
#include <fstream>
#include <functional>
#include <iomanip>
#include <iostream>
#include <iterator>
#include <limits>
#include <map>
#include <math.h>
#include <numeric>
#include <queue>
#include <random>
#include <regex>
#include <sstream>
#include <stack>
#include <string>
#include <string_view>
#include <thread>
#include <unistd.h>
#include <unordered_map>
#include <unordered_set>
#include <utility>
#include <vector>
// #include "json.hpp" // lib for json, dont forget to coment on contests
// #include <curl/curl.h> // lib for curl, dont forget to coment on contests
// #include <bit>
// #include "optimization.h"

// using json = nlohmann::json; // namespace for json, dont forget to coment on
// contests
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define ld long double

// #define FAST_ALLOCATOR_MEMORY 1e8
std::mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

// #pragma GCC optimize("Ofast")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2")

typedef tree<pair<int, int>, null_type, less<>, rb_tree_tag,
        tree_order_statistics_node_update>
        ordered_set;

const int INF = 1e18 + 7;
const int inf = 1e9 + 7;
const int MOD1 = 1e9 + 9;
const int P = 31;
const int P1 = 43;
const int MOD = 1e9 + 7;
const ld PI = acosl(-1);
const ld EPS = 1e-9;

const int MAX_BITSET = 123;

bitset<7> get_number(bitset<7> indicators, int number) {
    if (number == 0) {
        bitset<7> b("1110111");
        return indicators & b;
    }
    if (number == 1) {
        bitset<7> b("0010010");
        return indicators & b;
    }
    if (number == 2) {
        bitset<7> b("1011101");
        return indicators & b;
    }
    if (number == 3) {
        bitset<7> b("1011011");
        return indicators & b;
    }
    if (number == 4) {
        bitset<7> b("0111010");
        return indicators & b;
    }
    if (number == 5) {
        bitset<7> b("1101011");
        return indicators & b;
    }
    if (number == 6) {
        bitset<7> b("1101111");
        return indicators & b;
    }
    if (number == 7) {
        bitset<7> b("1010010");
        return indicators & b;
    }
    if (number == 8) {
        bitset<7> b("1111111");
        return indicators & b;
    }
    if (number == 9) {
        bitset<7> b("1111011");
        return indicators & b;
    }
}

int convert(bitset<7> indicators) {
    if (indicators.to_string() == "1110111") {
        return 0;
    }
    if (indicators.to_string() == "0010010") {
        return 1;
    }
    if (indicators.to_string() == "1011101") {
        return 2;
    }
    if (indicators.to_string() == "1011011") {
        return 3;
    }
    if (indicators.to_string() == "0111010") {
        return 4;
    }
    if (indicators.to_string() == "1101011") {
        return 5;
    }
    if (indicators.to_string() == "1101111") {
        return 6;
    }
    if (indicators.to_string() == "1010010") {
        return 7;
    }
    if (indicators.to_string() == "1111111") {
        return 8;
    }
    if (indicators.to_string() == "1111011") {
        return 9;
    }
    return -1;
}

void solve() {
    string s;
    bitset<7> first;
    cin >> s;
    reverse(s.begin(), s.end());
    for (int i = 0; i < s.size(); i++) {
        first[i] = s[i] - '0';
    }
    bitset<7> second;
    cin >> s;
    reverse(s.begin(), s.end());
    for (int i = 0; i < s.size(); i++) {
        second[i] = s[i] - '0';
    }
    int mx = 0;
    for (int i = 99; i > 0; i--) {
        bitset<7> f = get_number(first, i / 10);
        bitset<7> s = get_number(second, i % 10);

        if (convert(f) == -1 || convert(s) == -1) {
            continue;
        }

        int cur = 0;
        if (i > 9) {
            cur = convert(f) * 10;
        }
        cur += convert(s);
        // cout << "val " << i << ' ' << cur << '\n';
        int j = i - 1;
        while (j > 0) {
            f = get_number(first, j / 10);
            s = get_number(second, j % 10);

            if (convert(f) == -1 || convert(s) == -1) {
                break;
            }

            int cur1 = 0;
            if (j > 9) {
                cur1 = convert(f) * 10;
            }
            cur1 += convert(s);
            if (cur1 - 1 == cur) {
                j--;
                cur = cur1;
            } else {
                break;
            }
        }
        mx = max(mx, i - j - 1);
        // cout << i << ' ' << j << '\n';
    }
    cout << mx << '\n';
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    int t = 1;
    // cin >> t;
    //      t = readInt();
    while (t--) {
        solve();
        // solve1();
    }

    // while (!isEof()) {
    //     solve();
    // }

    return 0;
}
