import java.util.SortedSet
import kotlin.random.Random
import kotlin.math.log
import kotlin.math.ceil
import kotlin.math.log2


private fun readln() = readLine()!!
private fun readlnLong() = readln().toLong()

private fun readlnStrings() = readln().split(' ')
private fun readlnInts() = readlnStrings().map { it.toInt() }
private fun readlnLongs() = readlnStrings().map { it.toLong() }

private fun isWhiteSpace(c: Char) = c in " \r\n\t"
private fun readString() = generateSequence { System.`in`.read().toChar() }
    .dropWhile { isWhiteSpace(it) }.takeWhile { !isWhiteSpace(it) }.joinToString("")

private fun readInt() = readString().toInt()
private fun readLong() = readString().toLong()
private fun readFloat() = readString().toFloat()
private fun readDouble() = readString().toDouble()
private fun readBigInt(radix: Int = 10) = readString().toBigInteger(radix)
private fun readBigDecimal() = readString().toBigDecimal()
private fun readInts(n: Int) = generateSequence { readInt() }.take(n)
private fun readLongs(n: Int) = generateSequence { readLong() }.take(n)
private fun readFloats(n: Int) = generateSequence { readFloat() }.take(n)
private fun readDoubles(n: Int) = generateSequence { readDouble() }.take(n)

fun solve() {
    repeat(7) { readString() }
    val n = readString().dropLast(1).toInt()
    repeat(2) { readString() }

    val moves = mutableListOf<Pair<Int, Int>>()
    val fromTo = mutableMapOf<Int, Pair<Int, Int>>()

    while (true) {
        val word = readString()
        if (word != "if") {
            break
        }

        repeat(2) { readString() }
        val from = readString().dropLast(1).toInt()
        repeat(2) { readString() }
        val to = readString().dropLast(1).toInt()

        moves.add(Pair(from, to))
    }

    for (move in moves.reversed()) {
        val from = move.first
        val to = move.second

        val goTo = fromTo.getOrPut(to) { Pair(to + 1, 0) }

        fromTo[from] = Pair(goTo.first, goTo.second + 1)
    }

    val was = mutableSetOf<Int>()

    var last = 0
    var ans = 0
    while (true) {
        ans += 2
        if (last == n) {
            break
        }

        was.add(last)

        val (next, cost) = fromTo.getOrPut(last) { Pair(last + 1, 0) }

        ans += cost // Переходы (присваивания)
        ans += 1 // work
        ans += moves.size   // проверки

        last = next


        if (next in was) {
            println(-1)
            return
        }
    }

    println(ans)
}

fun main() {
    var n = 1
//    n = readInt()
    repeat(n) {
        solve()
    }
}
