#include <iostream>
#include <vector>
#include <cstdint>
#include <map>
#include <queue>
#include <tuple>
#include <set>

using namespace std;

constexpr int INF = INT_MAX;
unsigned d[1000][1000];

map<int, vector<int> > num_to_mask = {
    {0, {1, 1, 1, 0, 1, 1, 1}},
    {1, {0, 0, 1, 0, 0, 1, 0}},
    {2, {1, 0, 1, 1, 1, 0, 1}},
    {3, {1, 0, 1, 1, 0, 1, 1}},
    {4, {0, 1, 1, 1, 0, 1, 0}},
    {5, {1, 1, 0, 1, 0, 1, 1}},
    {6, {1, 1, 0, 1, 1, 1, 1}},
    {7, {1, 0, 1, 0, 0, 1, 0}},
    {8, {1, 1, 1, 1, 1, 1, 1}},
    {9, {1, 1, 1, 1, 0, 1, 1}}
};

map<vector<int>, int> mask_to_num;

int get_rep(int x, const string &broken) {
    vector<int> mask = num_to_mask[x];
    for (int i = 0; i < broken.size(); i++) {
        if (broken[i] == '0') {
            mask[i] = 0;
        }
    }
    if (mask_to_num.find(mask) == mask_to_num.end()) {
        return -INF;
    }
    return mask_to_num[mask];
}

void solve() {
    for (auto &[key, el]: num_to_mask) {
        mask_to_num[el] = key;
    }

    string m1, m2;
    cin >> m1 >> m2;

    int ans = 0, temp_ans = 0;
    int prev = 100;
    for (int cur = 99; cur > 0; cur--) {
        int ts = cur / 10;
        int s = cur % 10;
        int num = get_rep(s, m2);
        if (ts > 0) {
            num += get_rep(ts, m1) * 10;
        }
        if (cur == 39 || cur == 38) {
            //cerr << '!' << cur << ' ' << num << ' ' << prev << '\n';
        }
        if (num - prev == 1) {
            temp_ans++;
        } else {
            temp_ans = 0;
        }
        ans = max(ans, temp_ans);
        prev = num;
    }

    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    solve();
}
