#include <iostream>
#include <string>
#include <vector>
#include <bitset>

using namespace std;

vector<int> digits = {0b1110111, 0b0010010, 0b1011101, 0b1011011, 0b0111010,
                      0b1101011, 0b1101111, 0b1010010, 0b1111111, 0b1111011};

int f(int i) {
    return digits[i];
}

int GetDigit(int digit) {
    int i = 0;
    for (const auto& d : digits) {
        if (digit == d) {
            return i;
        }
        ++i;
    }
    return -1;
}

int AddMask(int digit, int mask) {
    int result = GetDigit(f(digit) & mask);

    return result;
}

int GetNumber(int d1, int d2, int mask1, int mask2) {
    int new_d1 = AddMask(d1, mask1);
    int new_d2 = AddMask(d2, mask2);
    //std::cout << "new_d1 = " << new_d1 << " | new_d2 = " << new_d2 << '\n';

    if (new_d1 > 9 || new_d1 < 0 || new_d2 > 9 || new_d2 < 0) {
        //cout << "None\n";
        return -1;

    }

    return new_d1 * 10 + new_d2;
}

int next(int d1, int d2, int mask1, int mask2) {
    int next_d1 = d1, next_d2 = d2;

    if (d2 == 0) {
        next_d1--;
        next_d2 = 9;
    }
    else {
        next_d2--;
    }
    if (next_d1 < 0) {
        return 0;
    }

    int next_number = GetNumber(next_d1, next_d2, mask1, mask2);
    int cur_number = GetNumber(d1, d2, mask1, mask2);
    //cout << cur_number << ' ' << next_number << '\n';

    if (next_number == -1) {
        return 0;
    }

    if (next_number == cur_number + 1) {
        return 1 + next(next_d1, next_d2, mask1, mask2);
    }
    else {
        return 0;
    }
}

signed main() {
    string a, b;
    cin >> a >> b;
    int mask1 = 0, mask2 = 0;
    for (int i = 6; i >= 0; --i) {
        mask1 = 2 * mask1 + (a[6 - i] - '0');
        mask2 = 2 * mask2 + (b[6 - i] - '0');
    }


    int max_window = 0;

    for (int y = 1; y <= 99; ++y) {
        int res = next(y / 10, y % 10, mask1, mask2);
        max_window = max(max_window, res);
    }

    cout << max_window << '\n';
}
