#include <bits/stdc++.h>

//namespace std {
//    std::ifstream input_file("rmq.in");
//    std::ofstream out_file("rmq.out");
//
//#define cin input_file
//#define cout out_file
//}

namespace tools {

    template<typename T>
    using vec = std::vector<T>;
    template<typename T>
    using mat = std::vector<std::vector<T>>;
    using str = std::string;
    using i64 = long long int;
    using u64 = unsigned long long int;
    using f64 = long double;

    static void fastIO() {
        std::ios_base::sync_with_stdio(false);
        std::cout.tie(nullptr);
        std::cin.tie(nullptr);
        std::cout.precision(12);
        std::fixed(std::cout);
    }

    template<typename T>
    auto& operator>>(std::istream& in, std::vector<T>& a) {
        for (T& elem: a) in >> elem; return in;
    }

    template<typename T>
    auto& operator<<(std::ostream& out, std::vector<T> const& a) {
        for (T const& elem: a) out << elem << ' '; return out;
    }


    std::mt19937_64 rn(std::chrono::steady_clock::now().time_since_epoch().count());
//    std::mt19937_64 rn(4);

} // namespace tools

using namespace tools;
//using namespace std;
using std::cin, std::cout, std::endl;

#define endl '\n'

void solver();

int32_t main() {
    fastIO();

    int T = 1;
    cin >> T;

    while (T--) {
        solver();
    }
}

str solver_solver(str s, i64 k) {
    int n = s.size();
    str result = "";

    std::set<std::pair<char, int>> aval;
    for (int i = 0; i < n; ++i) {
        aval.insert({s[i], i});
    }

    for (int i = 0; i < n; ++i) {
        auto it = aval.lower_bound({s[i], i});

        if (it != aval.begin() && k > 0) {
            --it;
            if (it->second <= i + k) {
                char digit = it->first;
                int pos = it->second;
                aval.erase(it);
                result += digit;
                k -= (pos - i);
                continue;
            } else {
                ++it;
            }
        }

        char digit = it->first;
        aval.erase(it);
        result += digit;
    }

    return result;
}

void solver() {
    str s;
    i64 k;
    cin >> s >> k;
    cout << solver_solver(s, k) << endl;
}