#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
const int inf = 1e9;


ll f(ll a, ll b) {
    return __gcd(a, b);
}

class tree {
public:
    tree(vector<ll> a, ll (*f)(ll, ll) = ::f, ll neu = 0)
            : n(a.size()), neu(neu), a(n), f(f) {
        this->a.resize(n);
        for (ll i = 0; i < n; ++i)
            this->a[i] = a[i];
        tr.resize(4 * n);
        build(0, 0, n);
    }
    void upd(ll i, ll x) { return updx(i, x, 0, 0, n); }
    ll getf(ll l, ll r) { return getfx(l, r, 0, 0, n); }

private:
    void build(ll p, ll l, ll r) {
        if (r - l == 1) {
            tr[p] = a[l];
            return;
        } else {
            ll m = (r + l) / 2;
            build(2 * p + 1, l, m);
            build(2 * p + 2, m, r);
            tr[p] = f(tr[2 * p + 1], tr[2 * p + 2]);
            return;
        }
    }
    void updx(ll i, ll x, ll p, ll sl, ll sr) {
        if (sr - sl == 1) {
            tr[p] = x;
            return;
        }
        ll sm = (sl + sr) / 2;
        if (i < sm)
            updx(i, x, 2 * p + 1, sl, sm);
        else
            updx(i, x, 2 * p + 2, sm, sr);
        tr[p] = f(tr[2 * p + 1], tr[2 * p + 2]);
    }
    ll getfx(ll l, ll r, ll p, ll sl, ll sr) {
        if (l >= r)
            return neu;
        if (l == sl and r == sr)
            return tr[p];

        ll sm = (sl + sr) / 2;
        return f(getfx(l, min(r, sm), 2 * p + 1, sl, sm),
                 getfx(max(l, sm), r, 2 * p + 2, sm, sr));
    }

    const ll n;
    const ll neu;
    vector<ll> a;
    ll (*f)(ll, ll);
    vector<ll> tr;
};

int main() {
    ll n;
    cin >> n;
    vector<ll> diffs;
    ll prev;
    cin >> prev;
    for (ll i = 1; i < n; ++i) {
        ll a;
        cin >> a;
        diffs.push_back(abs(a - prev));
        prev = a;
    }
    tree t(diffs);
    ll s, f;
    cin >> s >> f;
    --s;--f;
    bool reversed = false;
    if (s > f) {
        swap(s, f);
        reversed = true;
    }

    vector<pair<ll, pair<ll, ll>>> way;
    ll cur = s;

    while (cur < f) {
        ll next = cur;
        while (next + 1 <= f && t.getf(cur, next + 1) != 1) {
            ++next;
        }
        // cout << cur << " " << next << endl;s
        if (cur == next) {
            cout << "Impossible\n";
            return 0;
        }

        ll m = t.getf(cur, next);
        way.push_back({m == 0 ? 2 : m, {cur, next}});
        cur = next;
    }

    if (reversed) {
        reverse(way.begin(), way.end());
    }
    for (auto taxi : way) {
        if (!reversed) {
            cout << "Kaban-" << taxi.first << " " << taxi.second.first + 1 << " " << taxi.second.second + 1 << endl;
        } else {
            cout << "Kaban-" << taxi.first << " " << taxi.second.second + 1 << " " << taxi.second.first + 1 << endl;
        }
    }
}
