#include <vector>
#include <bitset>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <iostream>
#include <string>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>
#include <algorithm>
#include <functional>
#include <queue>
#include <numeric>

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())
#define x first
#define y second

inline void debug_out() { std::cerr << std::endl; }

template <typename Head, typename... Tail>
inline void debug_out(Head H, Tail... T) {
  std::cerr << " " << H;
  debug_out(T...);
}

#ifdef POSPELOV
#define db(...) std::cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define db(...) 42
#endif

template<typename T> bool smin(T &a, const T &b) { bool ret = b < a; return a = (a < b ? a : b), ret; }
template<typename T> bool smax(T &a, const T &b) { bool ret = a < b; return a = (b < a ? a : b), ret; }

typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;

using namespace std;

mt19937 rnd;

const int K = 65;
const int H = 1000;

const ll INF = 1ll * 1'000'000'000 * 1'000'000'000;

ll dp[K + 1][H + 1];

void pre() {
  for (int i = 0; i <= H; i++) {
    dp[0][i] = 1;
  }
  for (int k = 0; k < K; k++) {
    for (int h = 0; h <= H; h++) {
      ll cur = dp[k][h];
      smax(dp[k + 1][h], dp[k][h]);
      for (int x = 1; x + h <= H; x++) {
        cur += dp[k][h];
        smin(cur, INF);
        smax(dp[k + 1][h + x], cur);
      }
    }
  }
}

int solve() {
  ll n, k;
  cin >> n >> k;
  k *= 2;
  k++;
  if (k >= K) {
    k = K;
  }
  ll ans = 0;
  while (dp[k + 1][H] < n && k > 1) {
    k--;
    n = (n + 1) / 2;
    ans++;
    db(n);
  }
  if (k == 1) {
    return cout << ans + n - 1 << "\n", 0;
  }
  if (dp[k][H] >= n) {
    int l = -1, r = H, m;
    while (l + 1 < r) {
      m = (l + r) / 2;
      if (dp[k][m] >= n) {
        r = m;
      } else {
        l = m;
      }
    }
    cout << ans + r << "\n";
    return 0;
  }
  return 0;
}

signed main() {
  ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
  pre();
  int t;
  t = 1;
  cin >> t;
  while (t--) {
    solve();
  }
  return 0;
}