from dataclasses import dataclass


@dataclass
class Coord:
    x: int
    y: int

    def __lt__(self, other):
        return self.x < other.x


def main():
    n = int(input())
    coords = []
    for _ in range(n):
        x, y = map(int, input().split())
        if y < 0:
            y = -y
        coords.append(Coord(x, y))
    # print(coords)
    oX_coords = []
    up_coords = []
    for coord in coords:
        if coord.y > 0:
            up_coords.append(coord)
        else:
            oX_coords.append(coord)

    # print(f'{up_coords=}')

    if len(oX_coords) < 2 or len(up_coords) == 0:
        print(0)
        return

    oX_coords.sort()
    # print(f'{oX_coords=}')

    highest_dot = max(up_coords, key=lambda x: x.y)
    left_most_dot = oX_coords[0]
    right_most_dot = oX_coords[-1]

    amogus = (right_most_dot.x - left_most_dot.x) * highest_dot.y / 2
    print("{:.10f}".format(amogus))


if __name__ == '__main__':
    main()