#include <iostream>
#include <vector>
using namespace std;

const int MOD = 998244353;
long long fact(int &n);
long long modInv(long long &a);
long long count_arrangements(int &r, int &g, int &b);


int main() {
    int r, g, b;
    cin >> r >> g >> b;
    long long result = count_arrangements(r, g, b);
    cout << result << endl;

    return 0;
}




long long fact(int &n) {
    long long result = 1;
    for (int i = 2; i <= n; ++i) {
        result = (result * i) % MOD;
    }
    return result;
}
long long modInv(long long &a) {
    long long m = MOD, x0 = 0, x1 = 1;
    if (MOD == 1) return 0;
    while (a > 1) {
        long long q = a / m;
        long long t = m;
        m = a % m, a = t;
        t = x0;
        x0 = x1 - q * x0;
        x1 = t;
    }
    if (x1 < 0) x1 += MOD;
    return x1;
}
long long count_arrangements(int &r, int &g, int &b) {
    int max_count = max({ r, g, b });
    int All = r + g + b;
    if (max_count > (All - max_count + 1)) {
        return 0;
    }
    long long factAll = fact(All);
    long long Fr = fact(r);
    long long Fg = fact(g);
    long long Fb = fact(b);
    long long arrangements = factAll * modInv(Fr) % MOD;
    arrangements = arrangements * modInv(Fg) % MOD;
    arrangements = arrangements * modInv(Fb) % MOD;

    return arrangements;
}
