import sys

digits = [
    0b01110111,
    0b00010010,
    0b01011101,
    0b01011011,
    0b00111010,
    0b01101011,
    0b01101111,
    0b01010010,
    0b01111111,
    0b01111011,
]


def segment_to_digit(segment) -> int | None:
    try:
        return digits.index(segment)
    except ValueError:
        return None


def digit_from_segments(segment_1: int, segment_2: int, ignore_first=False):
    digit_1 = segment_to_digit(segment_1)
    digit_2 = segment_to_digit(segment_2)

    if ignore_first and digit_2 is not None:
        return digit_2

    if digit_1 is None or digit_2 is None:
        return None

    return digit_1 * 10 + digit_2


disp_1_mask = int(input(), 2)
disp_2_mask = int(input(), 2)

max_ = 0
curr_max = 0
prev_ = digit_from_segments(digits[9] & disp_1_mask, digits[9] & disp_2_mask)
for i in range(98, 9, -1):
    curr_ = digit_from_segments(digits[i // 10] & disp_1_mask, digits[i % 10] & disp_2_mask)
    if (prev_ is None or curr_ is None) or (curr_ != prev_ - 1):
        prev_ = curr_
        if curr_max > max_:
            max_ = curr_max
        curr_max = 0
        continue

    curr_max += 1
    prev_ = curr_

for i in range(9, 0, -1):
    curr_ = digit_from_segments(digits[i // 10] & disp_1_mask, digits[i % 10] & disp_2_mask, ignore_first=True)
    if (prev_ is None or curr_ is None) or (curr_ != prev_ - 1):
        prev_ = curr_
        if curr_max > max_:
            max_ = curr_max
        curr_max = 0
        continue

    curr_max += 1
    prev_ = curr_

print(max(max_, curr_max))
sys.stdout.flush()
