#include <cstdint>
#include <cstdio>
#include <iostream>
#include <ostream>

std::uint64_t solve(const std::uint64_t r, const std::uint64_t g,
                    const std::uint64_t b, const char added_ball = 'n') {
  if (r + g + b == 0) {
    return 1;
  }

  std::uint64_t res = 0;

  if (added_ball != 'r' && r > 0)
    res += solve(r - 1, g, b, 'r');

  if (added_ball != 'g' && g > 0)
    res += solve(r, g - 1, b, 'g');

  if (added_ball != 'b' && b > 0)
    res += solve(r, g, b - 1, 'b');

  return res % 998'244'353;
}

bool check(std::uint64_t const &r, std::uint64_t const &g,
           std::uint64_t const &b) {
  return !(r > g + b + 1 || g > r + b + 1 || b > r + g + 1);
}

int main() {
  std::ios_base::sync_with_stdio(false);
  std::cin.tie(0);
  std::cout.tie(0);

  std::uint64_t r, g, b;
  std::cin >> r >> g >> b;

  if (check(r, g, b)) {
    std::cout << solve(r, g, b) << std::endl;
  } else {
    std::cout << 0 << std::endl;
  }

  return 0;
}
