def is_valid_input(n, piles):
    if n <= 0:
        return False
    if len(piles) != n or any(x < 0 for x in piles):
        return False
    return True


def winner(piles):
    nim_sum = 0
    for pile in piles:
        nim_sum ^= pile
    return "Alice" if nim_sum != 0 else "Dmitry"


def main():
    try:
        n = int(input())
        piles = list(map(int, input().split()))

        if not is_valid_input(n, piles):
            print("Ошибка: Введите корректные данные.")
            return

        print(winner(piles))

    except ValueError:
        print("Ошибка: Введите корректные данные.")


if __name__ == "__main__":
    main()
