﻿#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>

using namespace std;

int main() {
    int n;
    cin >> n;
    vector<pair<int, int>> points(n);

    // Read points
    for (int i = 0; i < n; ++i) {
        cin >> points[i].first >> points[i].second;
    }

    vector<pair<int, int>> basePoints;
    // Collect base points on x-axis
    for (const auto& point : points) {
        if (point.second == 0) {
            basePoints.push_back(point);
        }
    }

    double maxArea = 0.0;

    // Calculate areas for each pair of base points
    for (size_t i = 0; i < basePoints.size(); ++i) {
        for (size_t j = i + 1; j < basePoints.size(); ++j) {
            int x1 = basePoints[i].first;
            int x2 = basePoints[j].first;

            // Check all other points to find height
            for (const auto& point : points) {
                if (point.second != 0) { // Not a base point
                    double height = abs(point.second);
                    double area = 0.5 * abs(x1 - x2) * height;
                    maxArea = max(maxArea, area);
                }
            }
        }
    }

    // Output result with precision
    cout  << maxArea << endl;

    return 0;
}
