import java.util.*;

public class Triangle {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int n = scanner.nextInt();
        List<int[]> points = new ArrayList<>();

        for (int i = 0; i < n; i++) {
            int x = scanner.nextInt();
            int y = scanner.nextInt();
            points.add(new int[]{x, y});
        }

        double maxArea = 0;
        List<int[]> xAxisPoints = new ArrayList<>();

        // Collect points on the x-axis
        for (int[] point : points) {
            if (point[1] == 0) {
                xAxisPoints.add(point);
            }
        }

        // Calculate maximum area
        for (int i = 0; i < xAxisPoints.size(); i++) {
            for (int j = i + 1; j < xAxisPoints.size(); j++) {
                int[] p1 = xAxisPoints.get(i);
                int[] p2 = xAxisPoints.get(j);
                double base = Math.abs(p2[0] - p1[0]);

                for (int[] point : points) {
                    if (point[1] != 0) { // Only consider points not on the x-axis
                        double height = Math.abs(point[1]);
                        double area = 0.5 * base * height;
                        maxArea = Math.max(maxArea, area);
                    }
                }
            }
        }

        System.out.printf("%.9f\n", maxArea);
    }
}
