import java.util.*;

public class Loops {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int t = scanner.nextInt(); // Number of test cases
        scanner.nextLine(); // Consume newline

        StringBuilder result = new StringBuilder();

        for (int i = 0; i < t; i++) {
            String[] input = scanner.nextLine().split(" ");
            String s = input[0];
            long k = Long.parseLong(input[1]);
            char[] digits = s.toCharArray();
            int n = digits.length;

            for (int j = 0; j < n && k > 0; j++) {
                // Find the minimum digit in the range [j, j + k]
                char minChar = digits[j];
                int minIndex = j;

                for (int l = j + 1; l < n && l <= j + k; l++) {
                    if (digits[l] < minChar) {
                        minChar = digits[l];
                        minIndex = l;
                    }
                }

                // If we found a smaller digit, perform swaps
                if (minIndex != j) {
                    // Calculate how many swaps are needed
                    int swapsNeeded = minIndex - j;

                    // If we have enough swaps left
                    if (swapsNeeded <= k) {
                        // Shift the found minimum character to position j
                        for (int l = minIndex; l > j; l--) {
                            // Swap adjacent elements
                            char temp = digits[l];
                            digits[l] = digits[l - 1];
                            digits[l - 1] = temp;
                        }
                        // Reduce k by the number of swaps used
                        k -= swapsNeeded;
                    }
                }
            }

            result.append(new String(digits)).append("\n");
        }

        System.out.print(result);
        scanner.close();
    }
}
