#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <sstream>
#include <fstream>
#include <cassert>
#include <bitset>

#include <sstream>
#include <istream>
#include <string>

#define optimization_lvl_GOD          \
    ios_base::sync_with_stdio(false); \
    cin.tie(nullptr);                 \
    cout.tie(nullptr)

using ll = long long;
using ull = unsigned long long;
using ld = long double;

#define YES cout << "YES\n"
#define NO cout << "NO\n"
#define line cout << "----------\n"

#define pb push_back
#define re return
#define last(x) x[x.size() - 1]

#define pll pair<ll,ll>
#define pld pair<ld,ld>

#define vec vector
#define vll vec<ll>
#define vld vec<ld>
#define vvll vec<vll>
#define vull vec<ull>
#define vvld vec<vld>
#define vb vec<bool>
#define vvb vec<vb>

#define all(vec) vec.begin(), vec.end()

#define print(a) for(auto &elem : a) cout << elem << ' '; cout << '\n'

#define fori(n) for(ll i = 0; i < n; ++i)
#define forj(n) for(ll j = 0; j < n; ++j)
#define input(vec) for(auto &elem : vec) cin >> elem;

using namespace std;

/*
ll step(ll a, ll n) {
    if (n == 1)
        return a;

    if (n % 2)
        return (step(a, n - 1) % MOD * a) % MOD;

    ll prev = step(a, n / 2) % MOD;
    return (prev * prev) % MOD;
}
*/

/*
set<ll> ez;
void resheto(ll n) {
    ez.clear();

    vec<bool> numbs(n, true);
    for (ll i = 2; i < n; i++)
        if (numbs[i]) {
            ez.insert(i);
            for (ll j = i; j < n; j += i)
                numbs[j] = false;
        }
}*/

/*bool Kuhn(ll &v, vvll &g, vb &visited, vll &ans) {
    if (visited[v]) {
        return false;
    }

    visited[v] = true;

    for(auto &i : g[v]) {
        if (ans[i] == -1 || Kuhn(ans[i], g, visited, ans)) {
            ans[i] = v;
            return true;
        }
    }

    return false;
}*/

//vec<pll> moveC{{0, 1}, {0, -1}, {1, 0}, {-1, 0}};

const ll MOD = 998244353,
        inf = INFINITY;
const ld PI = 3.141592653589793,
        eps = 1e-9,
        cfPI = PI / ld(180);

/*
bool binSearch(string &s, ll &len, ll k) {
    ll n = s.size();
    for(ll i = 0; (i < n) && k; ++i) {
        ll ptr = 0;
        bool check = true;
        while(true) {
            if (ptr == len) {
                break;
            }

            if ((s[i + ptr] != s[ptr]) || (i + ptr >= n)) {
                check = false;
                break;
            }

            ++ptr;
        }

        if (check) {
            i += ptr - 1;
            --k;
        }
    }

    return !k;
}
*/

vll parent;
vll high;

ll findParent(ll i) {
    if (parent[i] == i) {
        return i;
    }

    parent[i] = findParent(parent[i]);
    return parent[i];
}

void unite(ll i, ll j) {
    ll p1 = findParent(i);
    ll p2 = findParent(j);

    if (p1 == p2) {
        return;
    }

    if (high[p1] < high[p2])
        swap(p1, p2);

    parent[p2] = p1;
    high[p1] = max(high[p1], high[p2] + 1);
}

vvll check;
void dfs(ll cur, ll prev, ll dist, vec<vec<pll>> &m, ll start) {
    for(auto &i : m[cur]) {
        if (i.first == cur || i.first == prev) {
            continue;
        }

        check[start][i.first] = dist + i.second;

        //cout << start << ' ' << cur << ' ' << i << ' ' << dist << '\n';

        dfs(i.first, cur, dist + i.second, m, start);
    }
}

void solve() {
    ll n; cin >> n;

    parent.resize(n);
    for(int i = 0; i < n; ++i) {
        parent[i] = i;
    }
    high.resize(n, 1);

    vvll m(n, vll(n, 0));
    for(auto &i : m) {
        for(auto &j : i) {
            cin >> j;
        }
    }

    vec<pair<ll, pll>> edges;
    for(ll i = 0; i < n; ++i) {
        for(ll j = i; j < n; ++j) {
            edges.emplace_back(m[i][j], make_pair(i, j));
        }
    }

    sort(all(edges));

    vec<vec<pll>> m2(n);

    for(auto &i : edges) {
        ll f = i.second.first, s = i.second.second;

        ll p1 = findParent(f), p2 = findParent(s);

        if (p1 == p2) {
            continue;
        } else {
            m2[f].emplace_back(s, i.first);
            m2[s].emplace_back(f, i.first);

            unite(p1, p2);
        }
    }

    check.resize(n, vll(n, 0));
    for(int i = 0; i < n; ++i) {
        dfs(i, i, 0, m2, i);
    }

    if (check == m) {
        cout << "Yes";
    } else {
        cout << "No";
    }
}

int main() {
    optimization_lvl_GOD;

    ll t = 1;
    //cin >> t;

    while (t--)
        solve();
}

/*
                #################
              ############__######
           ######__#####__#####
          ######__####__######
           ####__####__####
            ###__###__###
             ##__##__##
               #__#__#
            ############################
        #+++==     =========       #############
      #==          ==========        ################
     #==          ==========          #################
#++++++             ===========          ##################
    #==          ==========           ####################
     #==         ===========          ###################
      #++         ===========        ##################
       #+++==      ============    ################
         ################################
             ==========================
              ###            ###
                ####           ####
                   ####           ####
*/
