import heapq

def minimize_number(t, test_cases):
    results = []
    
    for s, k in test_cases:
        s = list(s)
        n = len(s)
        
        for i in range(n):
            if k <= 0:
                break
            
            min_heap = []
            for j in range(i, min(n, i + k + 1)):
                heapq.heappush(min_heap, (s[j], j))
            
            min_digit, min_digit_index = heapq.heappop(min_heap)
            
            if min_digit_index != i:
                swaps_needed = min_digit_index - i
                if swaps_needed <= k:
                    for j in range(min_digit_index, i, -1):
                        s[j], s[j - 1] = s[j - 1], s[j]
                    k -= swaps_needed
        
        results.append(''.join(s))
    
    return results

t = int(input())
test_cases = [input().split() for _ in range(t)]
test_cases = [(s, int(k)) for s, k in test_cases]

results = minimize_number(t, test_cases)

for result in results:
    print(result)
