from collections import defaultdict, deque


def is_tree_matrix(n, matrix):
    # Проверка, что d[i][j] соответствует условиям дерева.
    for i in range(n):
        for j in range(n):
            for k in range(n):
                if matrix[i][j] < 0 or (i == j and matrix[i][j] != 0):
                    return "No"  # Положительные расстояния и нули на диагонали

                # Проверяем условие треугольного неравенства
                if matrix[i][j] > matrix[i][k] + matrix[k][j]:
                    return "No"

    # Проверка связности графа
    graph = defaultdict(list)

    for i in range(n):
        for j in range(i + 1, n):
            if matrix[i][j] > 0:
                graph[i].append(j)
                graph[j].append(i)

    visited = [False] * n

    # Функция BFS для проверки связности графа
    def bfs(start):
        queue = deque([start])
        visited[start] = True
        while queue:
            node = queue.popleft()
            for neighbor in graph[node]:
                if not visited[neighbor]:
                    visited[neighbor] = True
                    queue.append(neighbor)

    # Запускаем BFS от 0
    bfs(0)

    # Проверяем, все ли вершины были посещены
    if not all(visited):
        return "No"

    return "Yes"


# Ввод данных
n = int(input().strip())
matrix = [list(map(int, input().strip().split())) for _ in range(n)]

result = is_tree_matrix(n, matrix)
print(result)