def is_wooden_matrix(matrix):
    n = len(matrix)

    for i in range(n):
        if matrix[i][i] != 0:
            return "No"
        for j in range(n):
            if matrix[i][j] != matrix[j][i]:
                return "No"
            if i != j and matrix[i][j] <= 0:
                return "No"


    for i in range(n):
        for j in range(n):
            for k in range(n):
                if matrix[i][j] > matrix[i][k] + matrix[k][j]:
                    return "No"


    from collections import deque

    visited = [False] * n
    queue = deque([0])
    visited[0] = True
    while queue:
        current = queue.popleft()
        for neighbor in range(n):
            if not visited[neighbor] and matrix[current][neighbor] < float('inf'):
                visited[neighbor] = True
                queue.append(neighbor)

    if not all(visited):
        return "No"

    return "Yes"



n = int(input())
matrix = [list(map(int, input().split())) for _ in range(n)]


print(is_wooden_matrix(matrix))