#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

double find_max_ox(const vector<int>& dx, const vector<int>& dy, int n) {
	vector<int> xes;
	for (int i = 0; i < n; i++) {
		if (dy[i] == 0) {
			xes.push_back(dx[i]);
		}
	}

	if (xes.empty()) {
		return 0;
	}

	sort(xes.begin(), xes.end());
	return xes.back() - xes.front();
}

int main() {
	int n;
	cin >> n;

	vector<int> dots_x(n);
	vector<int> dots_y(n);

	for (int i = 0; i < n; i++) {
		cin >> dots_x[i] >> dots_y[i];
	}

	double max_ox = find_max_ox(dots_x, dots_y, n);
	double max_abs_y = *max_element(dots_y.begin(), dots_y.end(), [](int a, int b) {
		return abs(a) < abs(b);
	});

	double max_distance = max_ox * (abs(max_abs_y) / 2.0);

	cout << max_distance << endl;

	return 0;
}