#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool can_win(const vector<int>& piles) {
    int n = piles.size();
    vector<bool> dp(1 << n, false); 

    for (int state = 0; state < (1 << n); ++state) {
        for (int i = 0; i < n; ++i) {
            if (state & (1 << i)) {
                int new_state = state ^ (1 << i);
                if (!dp[new_state]) { 
                    dp[state] = true;
                    break;
                }
            }
        }
    }
    
    return dp[(1 << n) - 1];
}

int main() {
    int n;
    cin >> n; 
    vector<int> piles(n);
    
    for (int i = 0; i < n; ++i) {
        cin >> piles[i];
    }

    if (can_win(piles)) {
        cout << "Alice" << endl;
    } else {
        cout << "Dmitry" << endl;
    }

    return 0;
}