#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

void minimizeNumbers(const vector<pair<string, long long>>& testCases) {
    for (const auto& testCase : testCases) {
        string s = testCase.first;
        long long k = testCase.second;
        int n = s.size();

        for (int i = 0; i < n && k > 0; ++i) {
            long long limit = min(i + k, static_cast<long long>(n - 1));
            int minIndex = i;

            char minChar = '9' + 1;
            for (int j = i; j <= limit; ++j) {
                if (s[j] < minChar) {
                    minChar = s[j];
                    minIndex = j;
                }
            }

            if (minIndex != i) {
                s.erase(s.begin() + minIndex);
                s.insert(s.begin() + i, minChar);
                k -= (minIndex - i);
            }
        }

        cout << s << endl;
    }
}

int main() {
    int t;
    cin >> t;
    vector<pair<string, long long>> testCases(t);

    for (int i = 0; i < t; ++i) {
        string s;
        long long k;
        cin >> s >> k;
        testCases[i] = {s, k};
    }

    minimizeNumbers(testCases);

    return 0;
}
