#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

void minimizeNumbers(const vector<pair<string, long long>>& testCases) {
    for (const auto& testCase : testCases) {
        string s = testCase.first;
        long long k = testCase.second;
        int n = s.size();

        for (int i = 0; i < n && k > 0; ++i) {
            int minIndex = i;

            for (int j = i + 1; j <= min(i + k, static_cast<long long>(n - 1)); ++j) {
                if (s[j] < s[minIndex]) {
                    minIndex = j;
                }
            }

            if (minIndex != i) {
                char minChar = s[minIndex];
                s.erase(s.begin() + minIndex);
                s.insert(s.begin() + i, minChar);
                k -= (minIndex - i);
            }
        }

        cout << s << endl;
    }
}

int main() {
    int t;
    cin >> t;
    vector<pair<string, long long>> testCases(t);

    for (int i = 0; i < t; ++i) {
        string s;
        long long k;
        cin >> s >> k;
        testCases[i] = {s, k};
    }

    minimizeNumbers(testCases);
    return 0;
}
