def minimize_numbers(test_cases):
    results = []
    
    for s, k in test_cases:
        n = len(s)
        s = list(s)  # Преобразуем строку в список для удобства
        
        for i in range(n):
            # Определяем максимально возможный индекс для перемещения
            limit = min(i + k, n - 1)
            
            # Находим наименьшую цифру в диапазоне
            min_digit = '9' + '1'  # Цифры только от 1 до 9, инициализируем большим значением
            min_index = -1
            
            for j in range(i, limit + 1):
                if s[j] < min_digit:
                    min_digit = s[j]
                    min_index = j
            
            # Если мы нашли подходящую цифру
            if min_index != -1 and min_index != i:
                # Перемещаем цифру на позицию i, считая количество операций
                for j in range(min_index, i, -1):
                    s[j], s[j - 1] = s[j - 1], s[j]
                    k -= 1  # Уменьшаем количество операций
                
            if k <= 0:  # Если операции закончились, прерываем
                break
        
        results.append(''.join(s))  # Преобразуем список обратно в строку и добавляем в результаты
    
    return results


# Чтение данных
t = int(input())
test_cases = [input().strip().split() for _ in range(t)]
test_cases = [(s, int(k)) for s, k in test_cases]

# Получение результатов
results = minimize_numbers(test_cases)

# Вывод результатов
for result in results:
    print(result)