#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
using namespace std;

int main() {
    int t;
    cin >> t;
    cin.ignore(); // To ignore the newline after reading t

    while (t--) {
        string line;
        getline(cin, line);

        // Find s and k in the input line
        size_t space_idx = line.find(' ');
        string s_str = line.substr(0, space_idx);
        long long k = stoll(line.substr(space_idx + 1));

        vector<char> s(s_str.begin(), s_str.end());
        int n = s.size();

        vector<char> result;

        // If k is enough to fully sort the string
        if (k >= n * (n - 1) / 2) {
            sort(s.begin(), s.end());
            for (char c : s) cout << c;
            cout << endl;
            continue;
        }

        // Perform operations to get the minimal possible number
        while (k > 0 && !s.empty()) {
            int limit = min((long long)s.size(), k + 1);
            
            // Find the smallest digit in the limited range
            auto min_it = min_element(s.begin(), s.begin() + limit);
            int min_idx = distance(s.begin(), min_it);
            int swaps_needed = min_idx;

            k -= swaps_needed;
            result.push_back(*min_it);
            s.erase(s.begin() + min_idx);
        }

        // Append the remaining digits to the result
        result.insert(result.end(), s.begin(), s.end());
        
        for (char c : result) cout << c;
        cout << endl;
    }

    return 0;
}

