#include <iostream>
#include <vector>
#include <string>

using namespace std;

// Function to generate the smallest possible number by swapping with constraints
string getSmallestNumber(string s, long long k) {
    int n = s.size();
    
    for (int i = 0; i < n && k > 0; i++) {
        // Find the smallest number within the range of k moves from position i
        int pos = i;
        for (int j = i + 1; j < n && j - i <= k; j++) {
            if (s[j] < s[pos]) {
                pos = j;
            }
        }
        
        // Calculate the number of swaps needed to bring s[pos] to position i
        int swaps_needed = pos - i;

        // If we have enough swaps, perform them; otherwise, stop
        if (swaps_needed <= k) {
            k -= swaps_needed;
            char digit = s[pos];
            // Shift elements right to make space for s[pos] at position i
            for (int j = pos; j > i; j--) {
                s[j] = s[j - 1];
            }
            s[i] = digit;
        }
    }

    return s;
}

int main() {
    int t;
    cin >> t;
    vector<string> results;

    while (t--) {
        string s;
        long long k;
        cin >> s >> k;

        // Compute the smallest possible number for each test case
        results.push_back(getSmallestNumber(s, k));
    }

    // Output all results at once
    for (const auto &res : results) {
        cout << res << '\n';
    }

    return 0;
}

