from collections import deque, defaultdict

def find_shortest_path(n, population, s, f):

    graph = defaultdict(list)

    for m in range(2, 10**9 + 1):
        i = 0
        while i < n:
            j = i
            while j < n and population[j] % m == population[i] % m:
                j += 1

            for k in range(i, j):
                graph[k + 1].append((j, m))
            i = j


    queue = deque([(s, 0, [])])
    visited = set()

    while queue:
        current_city, steps, path = queue.popleft()

        if current_city == f:
            return steps, path

        for neighbor, m in graph[current_city]:
            if (neighbor, m) not in visited:
                visited.add((neighbor, m))
                new_path = path + [f"Kaban-{m} {current_city} {neighbor}"]
                queue.append((neighbor, steps + 1, new_path))

    return -1, []

n = int(input())
population = list(map(int, input().split()))
s, f = map(int, input().split())

steps, path = find_shortest_path(n, population, s, f)

if steps == -1:
    print("Impossible")
else:
    for line in path:
        print(line)
